
#define W_RIGHT  3
#define W_BOTTOM 4
#define WIN_WANT_ALL
#define WIN_WANT_SBS
#define WIN_WANT_EN
#define WIN_WANT_LBS
#define WIN_WANT_LB
#define WIN_WANT_CB
#define WIN_WANT_MF
#define WIN_WANT_IDM
#define WIN_WANT_HELP
#define WIN_WANT_DRAWTEXT
#define WIN_WANT_RESOURCE
#define WIN_WANT_CLIPBOARD
#define WIN_WANT_SYSTEM_METRICS
#define WIN_WANT_GETDEVCAPS

#define IDADD      508
#define IDCOLS     518

#include "windows.ch"
#include "inkey.ch"
#include "accel.ch"
#include "textmetr.ch"
#include "dialog.ch"
#include "font.ch"
#include "demo.ch"

STATIC aCols   := {}
STATIC aFields := {}
STATIC aFont   := {}
STATIC cLeft,cTop,cWidth,cHeight,cStyle,cColorSpec,cAutoLite,cTitle
STATIC aStyles := {"WS_POPUP",;
                   "WS_BORDER",;
                   "WS_CAPTION",;
                   "WS_SYSMENU",;
                   "WS_THICKFRAME",;
                   "WS_MINIMIZEBOX",;
                   "WS_MAXIMIZEBOX"}
STATIC cHeading,cBlock,cPicture,cFgcolor,cBgcolor,cAlign
STATIC lTest, cPath, cIndex, cAlias, cRDD
STATIC hMainWnd

FUNCTION BGen
       LOCAL cFile, nAnswer, cNtx, cMask

       hMainWnd := GetMainWnd()
       MessageBox(hMainWnd,"Write A Browse is designed as a tool for programmers"+CHR(13)+;
                           "to use when developing a browse for use within an"+CHR(13)+;
                           "application.  To compile, link and run the test"+CHR(13)+;
                           "program generated requires the WBrowse(s) library...","Notes",MB_OK)
       cFile    := ""
       cIndex   := ""
       IF !GetRDD( @cRDD )
          RETURN(NIL)
       ENDIF
       DO CASE
          CASE cRDD == "DBFNTX"
               cMask := "*.ntx"
          CASE cRDD == "DBFCDX"
               cMask := "*.idx;*.cdx"
          CASE cRDD == "DBFMDX"
               cMask := "*.mdx"
          CASE cRDD == "DBFNDX"
               cMask := "*.ndx"
       ENDCASE
       IF ErrorMsg(hMainWnd,"Please note that if you select a database"+CHR(13)+;
                            "that was NOT created using the RDD you"+CHR(13)+;
                            "selected then an error will result and the"+CHR(13)+;
                            "demo program will be terminated...",'W') == IDCANCEL
          RETURN(NIL)
       ENDIF

       cFile := GetOpenFileName( , "*.dbf", "Select a database" )
       IF EMPTY( cFile )
          RETURN(NIL)
       ENDIF
       cPath    := LEFT( cFile, RAT("\", cFile) - 1 )
       IF RIGHT(cPath, 1) != '\'
          cPath += '\'
       ENDIF
       IF "ATTEND" $ UPPER(cFIle) .OR.;
          "CHILD"  $ UPPER(cFile) .OR.;
          "RATES"  $ UPPER(cFile)
           ErrorMsg( hMainWnd, "FILE IN USE!", 'E' )
           RETURN(NIL)
       ENDIF
       USE (cFile) NEW VIA cRDD
       cIndex := GetOpenFileName(, cMask , "Select a index" )
       cAlias  := ALIAS()
       aCols   := {}
       aFields := {}
       lTest   := .F.
       aFont   := {}
       nAnswer := DialogBox( _GetInstance() , "bgen",,;
                             {|hDlg, nMsg, nWparam, nLparam|;
                             MBgen( hDlg, nMsg, nWparam, nLparam )} )

       DBCLOSEAREA( cFile )
       IF nAnswer == IDSAVE
          WriteBrow()
       ENDIF
RETURN(NIL)

STATIC FUNCTION ModColumns
       LOCAL nResults, aCFields := aFields

       nResults := DialogBox( _GetInstance() , "columns",,;
                              {|hDlg, nMsg, nWparam, nLparam|;
                              MColumns( hDlg, nMsg, nWparam, nLparam, aCFields )})
       IF nResults == IDOK
          RETURN(aCFields)
       ENDIF
RETURN(aFields)

STATIC FUNCTION MColumns( hDlgWnd, nMsg, nWparam, nLparam, aCFields )
       STATIC nCtr, nFlds, aStruc, hWnd

       DO CASE
          CASE nMsg == WM_INITDIALOG
               aStruc   := LoadAvail( aCFields )
               hWnd     := GetDlgItem( hDlgWnd, 101 )
               FOR nCtr := 1 TO LEN( aCFields )
                   SendMessage( hWnd, LB_ADDSTRING, 0, ALLTRIM(aCFields[nCtr][1]) )
               NEXT
               hWnd   := GetDlgItem( hDlgWnd, 102 )
               FOR nCtr := 1 TO LEN( aStruc )
                   SendMessage( hWnd, LB_ADDSTRING, 0, aStruc[nCtr][1] )
               NEXT
               EnableWindow( GetDlgItem( hDlgWnd, IDADD  ), .F. )
               EnableWindow( GetDlgItem( hDlgWnd, IDDEL  ), .F. )
               EnableWindow( GetDlgItem( hDlgWnd, IDEDIT ), .F. )
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == 101
                       IF C4W_HiWord(nLparam) == LBN_SELCHANGE
                          EnableWindow( GetDlgItem( hDlgWnd, IDDEL  ), .T. )
                          EnableWindow( GetDlgItem( hDlgWnd, IDADD  ), .F. )
                          EnableWindow( GetDlgItem( hDlgWnd, IDEDIT ), .T. )
                       ENDIF
                       RETURN(1)

                  CASE nWparam == 102
                       IF C4W_HiWord(nLparam) == LBN_SELCHANGE
                          EnableWindow( GetDlgItem( hDlgWnd, IDDEL  ), .F. )
                          EnableWindow( GetDlgItem( hDlgWnd, IDADD  ), .T. )
                          EnableWindow( GetDlgItem( hDlgWnd, IDEDIT ), .F. )
                       ENDIF
                       RETURN(1)

                  CASE nWparam == IDADD
                       AddDelCol( 1, hDlgWnd, aStruc, aCFields )
                       RETURN(1)

                  CASE nWparam == IDDEL
                       AddDelCol( 2, hDlgWnd, aStruc, aCFields )
                       RETURN(1)

                  CASE nWparam == IDEDIT
                       AddDelCol( 3, hDlgWnd, aStruc, aCFields )
                       RETURN(1)

                  CASE nWparam == IDOK
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam == IDEXIT .OR. nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION AddDelCol( nMode, hDlgWnd, aStruc, aCFields )
       LOCAL nSel, hFWnd, hTWnd, cText, nCtr

       hFWnd := GetDlgItem( hDlgWnd, 102 )
       hTWnd := GetDlgItem( hDlgWnd, 101 )
       DO CASE
          CASE nMode == 1 //ADD
               nSel     := SendMessage( hFWnd, LB_GETCURSEL, 0, 0 )
               cText    := SPACE( SendMessage( hFWnd, LB_GETTEXTLEN, nSel, 0 ))
               SendMessage( hFWnd, LB_GETTEXT, nSel, @cText )
               cText    := ALLTRIM( cText )
               FOR nCtr := 1 TO LEN( aStruc )
                   IF ALLTRIM( aStruc[nCtr][1] ) == cText
                      EXIT
                   ENDIF
               NEXT
               AADD( aCFields, {cText,aStruc[nCtr][2]} )
               SendMessage( hFWnd, LB_DELETESTRING, nSel, 0 )
               SendMessage( hTWnd, LB_ADDSTRING, 0, aCFields[LEN(aCFields)][1] )
               DefCol( aStruc[nCtr][1], aStruc[nCtr][2], aStruc[nCtr][3] )
               SetFocus( hDlgWnd )

          CASE nMode == 2 //DELETE
               nSel     := SendMessage( hTWnd, LB_GETCURSEL, 0, 0 )
               cText    := SPACE( SendMessage( hTWnd, LB_GETTEXTLEN, nSel, 0 ) )
               SendMessage( hTWnd, LB_GETTEXT, nSel, @cText )
               cText    := ALLTRIM( cText )
               FOR nCtr := 1 TO LEN( aCFields )
                   IF ALLTRIM( aCFields[nCtr][1] ) == cText
                      EXIT
                   ENDIF
               NEXT
               AADD( aStruc, {cText,aCFields[nCtr][2]} )
               ADEL( aCFields, nCtr )
               ASIZE( aCFields, LEN( aCFields ) -1 )
               ADEL( aCols, nCtr )
               ASIZE( aCols, LEN( aCols ) -1 )
               SendMessage( hTWnd, LB_DELETESTRING, nSel, 0 )
               SendMessage( hFWnd, LB_ADDSTRING, 0, aStruc[LEN( aStruc )][1] )

          CASE nMode == 3 //EDIT
               nSel     := SendMessage( hTWnd, LB_GETCURSEL, 0, 0 )
               cText    := SPACE( SendMessage( hTWnd, LB_GETTEXTLEN, nSel, 0 ) )
               SendMessage( hTWnd, LB_GETTEXT, nSel, @cText )
               cText    := ALLTRIM( cText )
               FOR nCtr := 1 TO LEN( aCFields )
                   IF ALLTRIM( aCFields[nCtr][1] ) == cText
                      EXIT
                   ENDIF
               NEXT
               DefCol( aStruc[nCtr][1], aStruc[nCtr][2], aStruc[nCtr][3] )
       ENDCASE
       EnableWindow( GetDlgItem( hDlgWnd, IDADD ), .F. )
       EnableWindow( GetDlgItem( hDlgWnd, IDDEL ), .F. )
RETURN(NIL)

STATIC FUNCTION LoadAvail( aCFields )
       LOCAL nCtr, nFlds
       LOCAL aStruc := {}
       LOCAL aTemp  := LdBrowFlds()
       LOCAL lAdd

       FOR nCtr := 1 TO LEN( aTemp )
           lAdd := .T.
           FOR nFlds := 1 TO LEN( aCFields )
               IF ALLTRIM( aTemp[nCtr][1] ) == ALLTRIM( aCFields[nFlds][1] )
                  lAdd := .F.
               ENDIF
           NEXT
           IF lAdd
              AADD( aStruc, {aTemp[nCtr][1],aTemp[nCtr][2],aTemp[nCtr][3]} )
           ENDIF
       NEXT
RETURN(aStruc)

STATIC FUNCTION DefCol( cTitle, cBlock, cPict )
       LOCAL nAnswer

       nAnswer := DialogBox( _GetInstance() , "addcol", ,  ;
                             {|hDlg, nMsg, nWparam, nLparam|;
                             MDefCol( hDlg, nMsg, nWparam, nLparam, cTitle, cBlock, cPict )})
RETURN(nAnswer)

STATIC FUNCTION MDefCol( hDlgWnd, nMsg, nWparam, nLparam, cTitle, cBlock, cPict )
       LOCAL aColors

       DO CASE
          CASE nMsg == WM_INITDIALOG
               SetDlgItemText( hDlgWnd, 101, cTitle )
               SetDlgItemText( hDlgWnd, 102, cBlock )
               SetDlgItemText( hDlgWnd, 103, cPict )
               SetDlgItemText( hDlgWnd, 114, '0' )
               SetDlgItemText( hDlgWnd, 115, '0' )
               SetDlgItemText( hDlgWnd, 116, '0' )
               SetDlgItemText( hDlgWnd, 117, '255' )
               SetDlgItemText( hDlgWnd, 118, '255' )
               SetDlgItemText( hDlgWnd, 119, '255' )
               CheckDlgButton( hDlgWnd, 104, 1 )
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)

                  CASE nWparam == 107
                       aColors := SelectColor( GetDlgItmText( hDlgWnd, 114 ),;
                                               GetDlgItmText( hDlgWnd, 115 ),;
                                               GetDlgItmText( hDlgWnd, 116 ) )
                       IF VALTYPE( aColors ) == 'A'
                          SetDlgItemText( hDlgWnd, 114, LTRIM( STR( aColors[1] ) ) )
                          SetDlgItemText( hDlgWnd, 115, LTRIM( STR( aColors[2] ) ) )
                          SetDlgItemText( hDlgWnd, 116, LTRIM( STR( aColors[3] ) ) )
                       ENDIF
                       RETURN(1)

                  CASE nWparam == 108
                       aColors := SelectColor( GetDlgItmText( hDlgWnd, 117 ),;
                                               GetDlgItmText( hDlgWnd, 118 ),;
                                               GetDlgItmText( hDlgWnd, 119 ) )
                       IF VALTYPE(aColors) == 'A'
                          SetDlgItemText( hDlgWnd, 117, LTRIM( STR(aColors[1] ) ) )
                          SetDlgItemText( hDlgWnd, 118, LTRIM( STR(aColors[2] ) ) )
                          SetDlgItemText( hDlgWnd, 119, LTRIM( STR(aColors[3] ) ) )
                       ENDIF
                       RETURN(1)

                  CASE nWparam == IDSAVE
                       cHeading := GetDlgItmText( hDlgWnd, 101 )
                       cBlock   := GetDlgItmText( hDlgWnd, 102 )
                       cPicture := GetDlgItmText( hDlgWnd, 103 )
                       DO CASE
                          CASE IsDlgButtonChecked( hDlgWnd, 104 ) == 1
                               cAlign := "DT_LEFT"
                          CASE IsDlgButtonChecked( hDlgWnd, 105 ) == 1
                               cAlign := "DT_CENTER"
                          CASE IsDlgButtonChecked( hDlgWnd, 106 ) == 1
                               cAlign := "DT_RIGHT"
                       ENDCASE
                       cFgcolor := "RGB(" + GetDlgItemText( hDlgWnd, 114 ) + ','
                       cFgcolor += GetDlgItemText( hDlgWnd, 115 ) + ','
                       cFgColor += GetDlgItemText( hDlgWnd, 116 ) + ')'
                       cBgcolor := "RGB(" + GetDlgItemText( hDlgWnd, 117 ) + ','
                       cBgcolor += GetDlgItemText( hDlgWnd, 118 ) + ','
                       cBgColor += GetDlgItemText( hDlgWnd, 119 ) + ')'
                       AADD( aCols,{cHeading,cBlock,cPicture,cFgcolor,cBgcolor,cAlign} )
                       EndDialog( hDlgWnd, IDSAVE )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION MBgen( hDlgWnd, nMsg, nWparam, nLparam )
       LOCAL nCtr, aColors

       DO CASE
          CASE nMsg == WM_INITDIALOG
               SetDlgItemText( hDlgWnd, 201, ALIAS() )
               SetDlgItemText( hDlgWnd, 101, '20' )
               SetDlgItemText( hDlgWnd, 102, '80' )
               SetDlgItemText( hDlgWnd, 103, '600' )
               SetDlgItemText( hDlgWnd, 104, '300' )
               CheckDlgButton( hDlgWnd, 107, 1 )
               CheckDlgButton( hDlgWnd, 108, 1 )
               CheckDlgButton( hDlgWnd, 109, 1 )
               CheckDlgButton( hDlgWnd, 110, 1 )
               CheckDlgButton( hDlgWnd, 111, 1 )
               CheckDlgButton( hDlgWnd, 112, 1 )
               SetDlgItemText( hDlgWnd, 114, '255' )
               SetDlgItemText( hDlgWnd, 115, '255' )
               SetDlgItemText( hDlgWnd, 116, '255' )
               SetDlgItemText( hDlgWnd, 214, '0' )
               SetDlgItemText( hDlgWnd, 215, '0' )
               SetDlgItemText( hDlgWnd, 216, '128' )
               SetDlgItemText( hDlgWnd, 117, '0' )
               SetDlgItemText( hDlgWnd, 118, '0' )
               SetDlgItemText( hDlgWnd, 119, '0' )
               SetDlgItemText( hDlgWnd, 217, '255' )
               SetDlgItemText( hDlgWnd, 218, '255' )
               SetDlgItemText( hDlgWnd, 219, '255' )
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)

                  CASE nWparam == IDCOLS
                       ModColumns()
                       SetFocus( hDlgWnd )
                       RETURN(1)

                  CASE nWparam == 301
                       aColors := SelectColor( GetDlgItmText( hDlgWnd, 114 ),;
                                               GetDlgItmText( hDlgWnd, 115 ),;
                                               GetDlgItmText( hDlgWnd, 116 ) )
                       IF VALTYPE(aColors) == 'A'
                          SetDlgItemText( hDlgWnd, 114, LTRIM( STR( aColors[1] ) ) )
                          SetDlgItemText( hDlgWnd, 115, LTRIM( STR( aColors[2] ) ) )
                          SetDlgItemText( hDlgWnd, 116, LTRIM( STR( aColors[3] ) ) )
                       ENDIF
                       RETURN(1)
                  CASE nWparam == 302
                       aColors := SelectColor( GetDlgItmText( hDlgWnd, 214 ),;
                                               GetDlgItmText( hDlgWnd, 215 ),;
                                               GetDlgItmText( hDlgWnd, 216 ) )
                       IF VALTYPE(aColors) == 'A'
                          SetDlgItemText( hDlgWnd, 214, LTRIM( STR( aColors[1] ) ) )
                          SetDlgItemText( hDlgWnd, 215, LTRIM( STR( aColors[2] ) ) )
                          SetDlgItemText( hDlgWnd, 216, LTRIM( STR( aColors[3] ) ) )
                       ENDIF
                       RETURN(1)
                  CASE nWparam == 303
                       aColors := SelectColor( GetDlgItmText( hDlgWnd, 117 ),;
                                               GetDlgItmText( hDlgWnd, 118 ),;
                                               GetDlgItmText( hDlgWnd, 119 ) )
                       IF VALTYPE(aColors) == 'A'
                          SetDlgItemText( hDlgWnd, 117, LTRIM( STR( aColors[1] ) ) )
                          SetDlgItemText( hDlgWnd, 118, LTRIM( STR( aColors[2] ) ) )
                          SetDlgItemText( hDlgWnd, 119, LTRIM( STR( aColors[3] ) ) )
                       ENDIF
                       RETURN(1)
                  CASE nWparam == 304
                       aColors := SelectColor( GetDlgItmText( hDlgWnd, 217 ),;
                                               GetDlgItmText( hDlgWnd, 218 ),;
                                               GetDlgItmText( hDlgWnd, 219 ) )
                       IF VALTYPE(aColors) == 'A'
                          SetDlgItemText( hDlgWnd, 217, LTRIM( STR( aColors[1] ) ) )
                          SetDlgItemText( hDlgWnd, 218, LTRIM( STR( aColors[2] ) ) )
                          SetDlgItemText( hDlgWnd, 219, LTRIM( STR( aColors[3] ) ) )
                       ENDIF
                       RETURN(1)

                  CASE nWparam == IDFONT
                       GetNewFont()
                       RETURN(1)

                  CASE nWparam == IDSAVE
                       IF LEN( aCols ) == 0
                          ErrorMsg( hDlgWnd, "NO COLUMNS DEFINED!", 'E' )
                          SetFocus( hDlgWnd )
                          RETURN(1)
                       ENDIF
                       lTest   := IIF( IsDlgButtonChecked( hDlgWnd, 120 ) == 1, .T., .F. )
                       cTitle  := GetDlgItmText( hDlgWnd, 201 )
                       cLeft   := GetDlgItmText( hDlgWnd, 101 )
                       cTop    := GetDlgItmText( hDlgWnd, 102 )
                       cWidth  := GetDlgItmText( hDlgWnd, 103 )
                       cHeight := GetDlgItmText( hDlgWnd, 104 )
                       cStyle  := ""
                       FOR nCtr := 105 TO 111
                           IF IsDlgButtonChecked( hDlgWnd, nCtr ) == 1
                              cStyle += aStyles[nCtr-104] + '+'
                           ENDIF
                       NEXT
                       IF RIGHT(cStyle,1) == '+'
                          cStyle := LEFT( cStyle, LEN( cStyle ) -1 )
                       ENDIF
                       cAutoLite  := IIF( IsDlgButtonChecked( hDlgWnd, 112 ) == 1, '.T.', '.F.' )
                       cColorSpec := "RGB("
                       FOR nCtr := 117 TO 119
                           cColorSpec += GetDlgItmText( hDlgWnd, nCtr )
                           IF nCtr != 119
                              cColorSpec += ','
                           ENDIF
                       NEXT
                       cColorSpec += '), RGB('
                       FOR nCtr := 217 TO 219
                           cColorSpec += GetDlgItmText( hDlgWnd, nCtr )
                           IF nCtr != 219
                              cColorSpec += ','
                           ENDIF
                       NEXT
                       cColorSpec += '), RGB('
                       FOR nCtr := 114 TO 116
                           cColorSpec += GetDlgItmText( hDlgWnd, nCtr )
                           IF nCtr != 116
                              cColorSpec += ','
                           ENDIF
                       NEXT
                       cColorSpec += '), RGB('
                       FOR nCtr := 214 TO 216
                           cColorSpec += GetDlgItmText( hDlgWnd, nCtr )
                           IF nCtr != 216
                              cColorSpec += ','
                           ENDIF
                       NEXT
                       cColorSpec += ')'
                       EndDialog( hDlgWnd, IDSAVE )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

// This is kind of crude but works....
//
STATIC FUNCTION WriteBrow
       LOCAL cWrkDir  := GetModuleFileName()
       LOCAL nCtr

       SetCursor(IDC_ARROW)
       Working( .T., "Creating/Writing test program..." )
       cWrkDir := LEFT( cWrkDir, RAT("\", cWrkDir) - 1 )
       IF RIGHT( cWrkDir, 1 ) != '\'
          cWrkDir += '\'
       ENDIF
       SpinBall()
       SET CONSOLE OFF
       SET PRINTER TO ( cWrkDir+"TEST.PRG" )
       SET PRINTER ON
       IF lTest
          WriteHeader()
       ENDIF
       ?
       ? "STATIC FUNCTION Browse"
       ? "       STATIC oB"
       ?
       ? "       IF lBrowse"
       ? "          oB:Destroy()"
       ? "       ENDIF"
       ? "       SELECT "+cAlias
       ? "       oB := WBrowseDB(GetFocus(),;"
       ? "                       "+cLeft+',;'
       ? "                       "+cTop+',;'
       ? "                       "+cWidth+',;'
       ? "                       "+cHeight+',;'
       ? "                       "+CHR(34)+cTitle+CHR(34)+',;'
       ? "                       "+cStyle+')'
       ?
       FOR nCtr := 1 TO LEN(aCols)
           IF !EMPTY(aCols[nCtr][3])
              aCols[nCtr][3] := CHR(34)+aCols[nCtr][3]+CHR(34)
           ENDIF
           SpinBall()
           aCols[nCtr][4] := "{||"+aCols[nCtr][4]+"}"
           aCols[nCtr][5] := "{||"+aCols[nCtr][5]+"}"
           ? "       oB:addColumn(WBColumnNew("+CHR(34)+aCols[nCtr][1]+CHR(34)+','+;
                                                aCols[nCtr][2]+','+;
                                                aCols[nCtr][3]+','+;
                                                aCols[nCtr][4]+','+;
                                                aCols[nCtr][5]+','+;
                                                aCols[nCtr][6]+'))'
       NEXT
       ? "       oB:autoLite     := "+cAutoLite
       ? "       oB:colorSpec    := {"+cColorSpec+'}'
       ? "       oB:escape       := .T."
       ? "       oB:destroyBlock := {||UnQueBrow()}"
       ? '       oB:doubleClick  := {||ErrorMsg(oB:hWnd,"EDITS/DELETES NOT ALLOWED!","E"),SetFocus(oB:hWnd)}'
       IF !EMPTY( aFont )
       ? '       oB:setFont(CreateFont('+FontArray()+'))'
       ? "       oB:configure()"
       ENDIF
       ? '       AADD(aObjs,{oB,oB:hWnd,"TEST.PRG"})'
       ? "       lBrowse := .T."
       ? "       oB:goTop()"
       ? "RETURN(NIL)"
       SpinBall()
       IF lTest
          WriteFooter()
       ENDIF
       SET PRINTER OFF
       SET PRINTER TO ( cWrkDir+"TEST.RMK" )
       SET PRINTER ON
       ? ".prg.obj:                "
       ? "        clipper $< /n /w "
       ? "                         "
       ? "test.obj   : test.prg    "
       ? "test.exe   : test.obj    "
       ? " link /A:16/se:1028/NOE test+common,,nul,"+cRDD+" clip4win wbrowses,test.def"
       ? " rc -k demo.res test.exe"
       SET PRINTER OFF
       SET PRINTER TO
       SET CONSOLE ON
       SetCursor( IDC_ARROW )
       Working( .F. )
       Message( hMainWnd, "" )
       WinExec( "NOTEPAD.EXE " + cWrkDir + "TEST.PRG" )
RETURN(NIL)

STATIC FUNCTION SelectColor( cRed, cGreen, cBlue )
       LOCAL nColor

       nColor := RGB( VAL(cRed) , VAL(cGreen) , VAL(cBlue) )
       nColor := ChooseColor( nColor )
       IF nColor >= 0
          RETURN( {GetRValue( nColor ), GetGValue( nColor ), GetBValue( nColor )} )
       ENDIF
RETURN(NIL)

STATIC FUNCTION WriteHeader

       SpinBall()
       SELECT TESTSRC
       SpinBall()
       SEEK "1010"
       SpinBall()
       REPLACE TESTSRC->LINE WITH "// "+DTOC(DATE())+ ' - ' + TIME()
       SpinBall()
       SEEK "1590"
       REPLACE TESTSRC->LINE WITH "       SET PATH TO "+cPath
       SKIP
       REPLACE TESTSRC->LINE WITH "       REQUEST "+cRDD
       SpinBall()
       SEEK "1750"
       REPLACE TESTSRC->LINE WITH "       USE "+cAlias+" NEW VIA "+CHR(34)+cRDD+CHR(34)
       SpinBall()
       SKIP
       SpinBall()
       IF !EMPTY( cIndex )
          REPLACE TESTSRC->LINE WITH "       SET INDEX TO "+cIndex
       ELSE
          REPLACE TESTSRC->LINE WITH "       // NO INDEX SELECTED"
       ENDIF
       SpinBall()
       SELECT TESTSRC
       SpinBall()
       GO TOP
       DO WHILE TESTSRC->LINENO < "2000"
          SpinBall()
          ? TESTSRC->LINE
          SKIP
       ENDDO
       SpinBall()
RETURN(NIL)

STATIC FUNCTION WriteFooter

       DO WHILE !EOF()
          SpinBall()
          ? TRIM( TESTSRC->LINE )
          SKIP
       ENDDO
RETURN(NIL)

STATIC FUNCTION GetNewFont
       LOCAL nColor := RGB(0,0,0)
       LOCAL cDesc

       aFont := {10, 0, 0, 0, 0, .F., .F., .F., 1, 0, 0, 0, 0, "Arial"}
       aFont := ChooseFont( aFont,,, @nColor )
RETURN(NIL)

STATIC FUNCTION FontArray
       LOCAL cFont := '{', nCtr

       FOR nCtr := 1 TO LEN(aFont)
           DO CASE
              CASE VALTYPE( aFont[ nCtr ] ) == 'N'
                   cFont += LTRIM( STR( aFont[ nCtr ] ) )
              CASE VALTYPE( aFont[ nCtr ] ) == 'L'
                   cFont += LTOC( aFont[ nCtr ] )
              CASE VALTYPE( aFont[ nCtr ] ) == 'C'
                   cFont += CHR(34) + ALLTRIM( aFont[ nCtr ] ) + CHR(34)
           ENDCASE
           IF nCtr != LEN(aFont)
              cFont += ','
           ELSE
              cFont += '}'
           ENDIF
        NEXT
RETURN( cFont )

