

#define W_RIGHT  3
#define W_BOTTOM 4
#define WIN_WANT_ALL
#define WIN_WANT_SBS
#define WIN_WANT_EN
#define WIN_WANT_LBS
#define WIN_WANT_LB
#define WIN_WANT_CB
#define WIN_WANT_MF
#define WIN_WANT_IDM
#define WIN_WANT_HELP
#define WIN_WANT_DRAWTEXT
#define WIN_WANT_RESOURCE
#define WIN_WANT_CLIPBOARD
#define WIN_WANT_SYSTEM_METRICS
#define WIN_WANT_GETDEVCAPS

#define BDOB   2001
#define BNAME  2002
#define BRACE  2003
#define BSEX   2004
#define BCCODE 2005

#include "windows.ch"
#include "inkey.ch"
#include "accel.ch"
#include "textmetr.ch"
#include "dialog.ch"
#include "font.ch"
#include "demo.ch"

STATIC cCopy    := "Copyright 1994, Logical Systems"
STATIC hMainWnd
STATIC hCTL3D
STATIC hToolBar
STATIC hBWCCLib
STATIC hMenu
STATIC nTH
STATIC nMainWW
STATIC aButtons[16]
STATIC lBtnMsg  := .F.
STATIC lBPrompt := .T.
STATIC lBrowse  := .F.
STATIC cBtnMsg  := " "
STATIC aObjs    := {}
STATIC cPath
STATIC cRDD
STATIC aBtnMsgs := {"Left < oB:left() >...",;
                    "Right < oB:right() >...",;
                    "Up < oB:up() >...",;
                    "Down < oB:down() >...",;
                    "PgUp < oB:pageUp() >...",;
                    "PgDn < oB:pageDown >...",;
                    "First Column < oB:panHome() >...",;
                    "Last Column < oB:panEnd() >...",;
                    "Top < oB:goTop() >...",;
                    "Bottom < oB:goBottom() >...",;
                    "Change Font < oB:setFont() > + < oB:refreshALL() >...",;
                    "Edit Record...",;
                    "Delete Record...",;
                    "Refresh < oB:refreshAll() >...",;
                    "View Browse source code...",;
                    "Exit Browse < oB:destroy() >...",;
                    "Help..."}

STATIC SCCODE,SLAST_NAME,SFIRST_NAME,SMI,SJR_SR_III,SNOTES,SRACE,SSEX

FUNCTION Main
       LOCAL hInst, nEvent, cC3D, aCrect := {}, cWrkDir

       REQUEST DBFCDX
       REQUEST DBFNTX
       REQUEST DBFNDX
       REQUEST DBFMDX

       cWrkDir  := GetModuleFileName()
       cPath    := LEFT(cWrkDir, RAT("\", cWrkDir) - 1)
       IF RIGHT(cPath, 1) != '\'
          cPath += '\'
       ENDIF
       SET DELETED ON
       SET SCOREBOARD OFF

       hInst    := _GetInstance()
       hCTL3D   := LoadLibrary("CTL3D.DLL")
       hBWCCLib := LoadLibrary("BWCC.DLL")
       hMainWnd := WinSetup("DEMO","WBrowse(s) Version 1.40 Demo")
       aCRect   := GetClientRect(hMainWnd)
       nMainWW  := aCRect[ W_RIGHT ]
       nTH      := TextHeight()
       HideCaret(hMainWnd)
       BringWindowToTop(hMainWnd)
       SetMainWnd(hMainWnd)
       Ctl3DRegister(hInst)
       Ctl3dAutoSubClass(hInst)
       SetTimer(hMainWnd,1,100)
       DoSubCl(hMainWnd)
       SetHandleCount(30)
       C4W_Autoclose(.F.)
       LoadBalls()
       MsgBar()
       ShowLogo()
       ToolBar()
       SetFocus(hMainWnd)
       SetCursor(LoadCursor(,IDC_ARROW ) )
       DO WHILE .T.
          nEvent := ChkEvent()
          HandleEvent(nEvent)
       ENDDO
RETURN(NIL)

STATIC FUNCTION ShowLogo

       Working(.T.,"Please Wait - Getting ready...")
       SpinBall()
       USE CHILD NEW VIA "DBFNTX"
       SpinBall()
       SET INDEX TO CHILD
       SpinBall()
       USE ATTEND NEW VIA "DBFNTX"
       SpinBall()
       SET INDEX TO ATTEND
       SpinBall()
       USE BUTTONS NEW VIA "DBFNTX"
       SpinBall()
       USE TESTSRC NEW VIA "DBFNTX"
       SET INDEX TO TESTSRC
       USE CAL NEW VIA "DBFNTX"
       SET INDEX TO CAL
       Working(.F.)
       SetCursor( LoadCursor(, IDC_ARROW ) )
       Message(hMainWnd,"")
RETURN(NIL)

STATIC FUNCTION DoExit()

       IF ByeBye() == IDYES
          PgmExit()
       ENDIF
RETURN(NIL)

STATIC FUNCTION ByeBye
       LOCAL nAnswer

       SelectWindow(hMainWnd)
       nAnswer := DialogBox(_GetInstance() , "quit", ,  ;
                            {|hDlg, nMsg, nWparam, nLparam|;
                            MBye(hDlg, nMsg, nWparam, nLparam)})
RETURN(nAnswer)

STATIC FUNCTION MBye(hDlgWnd, nMsg, nWparam, nLparam)

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow(hDlgWnd)
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDNO .OR. nWparam == IDCANCEL
                       EndDialog(hDlgWnd,IDNO)
                       RETURN(1)

                  CASE nWparam == IDYES
                       EndDialog(hDlgWnd,IDYES)
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION WinSetup(cAppName, cTitle)
       LOCAL  hWnd, hInst, hPrevInst, nCmdShow, hBrush, hIcon

       hInst     := _GetInstance()
       hPrevInst := _GetPrevInstance()
       nCmdShow  := _GetnCmdShow()
*      hBrush    := GetStockObject(WHITE_BRUSH)
       hIcon     := LoadIcon(hInst,"DEMO"+CHR(0))
       hMenu     := LoadMenu(hInst,"DEMO"+CHR(0))
       hBrush    := LoadDIBBrush( hInst, 1100 )
       IF hPrevInst == 0
          IF !RegisterClass(CS_HREDRAW + CS_VREDRAW + CS_SAVEBITS + CS_DBLCLKS,;
                            hInst, ;
                            hIcon, ;
                            LoadCursor(hInst,IDC_ARROW),;
                            hBrush,;
                            cAppName)

             QUIT
         ENDIF
         IF !RegisterClass(CS_HREDRAW + CS_VREDRAW + CS_SAVEBITS + CS_DBLCLKS,;
                           hInst, ;
                           hIcon, ;
                           LoadCursor(,IDC_ARROW),;
                           GetStockObject(LTGRAY_BRUSH),;
                           'TB')

             QUIT
         ENDIF

         // We want our icon on minimized browse windows so we get rid of
         // the WBrowse() class and re-register it with our app icon

         UnregisterClass("BLIST",hInst)
         IF !RegisterClass(CS_HREDRAW + CS_VREDRAW + CS_SAVEBITS + CS_DBLCLKS,;
                           hInst, ;
                           hIcon, ;
                           LoadCursor(,IDC_ARROW),;
                           hBrush,;
                           "BLIST")

            QUIT
         ENDIF
      ENDIF
      hWnd := CreateWindow(cAppName,    ;
                           cTitle,      ;
                           WS_CLIPCHILDREN + WS_CAPTION + WS_SYSMENU + WS_MINIMIZEBOX + WS_MAXIMIZEBOX,;
                           0,           ;
                           0,           ;
                           640,         ;
                           440,         ;
                           0,           ;
                           hMenu,       ;
                           hInst)
      ShowWindow(hWnd, nCmdShow)
      UpdateWindow(hWnd)
RETURN(hWnd)
FUNCTION PgmExit
       LOCAL nCtr, oB

       FOR nCtr := 1 TO LEN(aButtons)
           DestroyWindow(aButtons[nCtr])
       NEXT
       Ctl3DUnRegister(_GetInstance())
       KillTimer(hMainWnd,1)
       FreeLibrary(hCTL3D)
       FreeLibrary(hBWCCLib)
       WinHelp(hMainWnd,"WINHELP.HLP",HELP_QUIT,0)
       WinHelp(hMainWnd,"WBROWSES.HLP",HELP_QUIT,0)
       IF lBrowse
          oB := GetActiveBrowse()
          DestroyWindow(oB:hWnd)
       ENDIF
       DestroyWindow(hToolBar)
       DestroyWindow(hMainWnd)
       UnregisterClass("DEMO",_GetInstance())
       UnregisterClass('TB',_GetInstance())
       QUIT
RETURN(NIL)

STATIC FUNCTION LoadMenu(hInst,cMenu)
       LOCAL cLDM
       LOCAL hMenu
       LOCAL hLib := LoadLibrary("USER.EXE")

       cLDM := GetProcAddress(hLib, "LoadMenu", ;
                              "Pascal", "int", "int,string")
       hMenu := CallDLL(cLDM, hInst, cMenu)
       FreeLibrary(hLib)
RETURN(hMenu)

STATIC FUNCTION WndProc(nProc, hWnd, nMsg, nWparam, nLparam)
       LOCAL  nCtr, aCRect := {}, oB, hFont

       DO CASE
          CASE nMsg == WM_NCHITTEST
               IF lBPrompt
                  IF lBtnMsg
                     Message(hMainWnd,"")
                     lBtnMsg := .F.
                     cBtnMsg := " "
                  ENDIF
               ENDIF

          CASE nMsg == WM_SIZE
               aCRect := GetClientRect(hMainWnd)
               IF aCRect[ W_RIGHT ] > nMainWW
                  IF hToolBar != NIL
                     FOR nCtr := 1 TO LEN(aButtons)
                         DestroyWindow(aButtons[nCtr])
                     NEXT
                     DestroyWindow(hToolBar)
                     ToolBar()
                  ENDIF
               ENDIF

          CASE nMsg == WM_TIMER
               UpDtTime()

          CASE nMsg == WM_SYSCOMMAND
               IF nWparam == SC_CLOSE
                  IF ByeBye() == IDYES
                     PgmExit()
                  ENDIF
               ENDIF

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDLEFT
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:left()
                       ENDIF
                  CASE nWparam == IDRIGHT
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:right()
                       ENDIF
                  CASE nWparam == IDUP
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:up()
                       ENDIF
                  CASE nWparam == IDDOWN
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:down()
                       ENDIF
                  CASE nWparam == IDTOP
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:goTop()
                       ENDIF
                  CASE nWparam == IDBOTTOM
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:goBottom()
                       ENDIF
                  CASE nWparam == IDHOME
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:panHome()
                       ENDIF
                  CASE nWparam == IDEND
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:panEnd()
                       ENDIF
                  CASE nWparam == IDREFALL
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:refreshAll()
                       ENDIF
                  CASE nWparam == IDBEXIT
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:Destroy()
                       ENDIF
                  CASE nWparam == IDPGUP
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:pageUp()
                       ENDIF
                  CASE nWparam == IDPGDN
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          oB:pageDown()
                       ENDIF
                  CASE nWparam == IDFONT
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          hFont := GetNewFont()
                          IF hFont != NIL
                             oB:SetFont(hFont)
                             oB:configure()
                             oB:refreshAll()
                          ENDIF
                       ENDIF
                  CASE nWparam == IDEDIT
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          IF oB:doubleClick != NIL
                             EVAL(oB:doubleClick,oB,oB:nCrecNo,IDEDIT)
                          ENDIF
                       ENDIF
                  CASE nWparam == IDDEL
                       oB := GetActiveBrowse()
                       IF oB != NIL
                          IF oB:doubleClick != NIL
                             EVAL(oB:doubleClick,oB,oB:nCrecNo,IDDEL)
                          ENDIF
                       ENDIF
                  CASE nWparam == IDEXIT
                       IF ByeBye() == IDYES
                          PgmExit()
                       ENDIF
                  CASE nWparam == DEMO1
                       Browse1()
                  CASE nWparam == DEMO2
                       Browse2()
                  CASE nWparam == DEMO3
                       Browse3()
                  CASE nWparam == DEMO4
                       Browse4()
                  CASE nWparam == DEMO5
                       Browse5()
                  CASE nWparam == DEMO6
                       Browse6()
                  CASE nWparam == DEMO7
                       Browse7()
                  CASE nWparam == DEMO9
                       BGen()
                  CASE nWparam == IDORDER
                       OrderForm()
                  CASE nWparam == IDBHELP .OR. nWparam == IDHELP
                       WinHelp(hMainWnd,"WBROWSES.HLP",HELP_INDEX)
                  CASE nWparam == IDABOUT
                       About()
               ENDCASE

          CASE nMsg == WM_NCHITTEST
               IF lBtnMsg
                  Message(hMainWnd,"")
                  lBtnMsg := .F.
                  cBtnMsg := " "
               ENDIF

          CASE nMsg == WM_PAINT
               MsgBar(hMainWnd)
               Message(hMainWnd,"")

          CASE nMsg == WM_KEYDOWN .OR. nMsg == WM_SYSKEYDOWN
               IF nWparam == VK_F1
                  WinHelp(hMainWnd,"WBROWSES.HLP",HELP_INDEX)
               ELSE
                  oB := GetActiveBrowse()
                  IF oB != NIL
                     PostMessage(oB:hWnd,nMsg,nWparam,nLparam)
                  ENDIF
               ENDIF
       ENDCASE
RETURN(CallWindowProc(nProc, hWnd, nMsg, nWparam, nLparam))

STATIC FUNCTION DoSubCl(hWnd)
       LOCAL nProc

       nProc := SubClassWindow(hWnd,;
                   {|hWnd, nMsg, nWparam, nLparam| ;
                   WndProc(nProc, hWnd, nMsg, nWparam, nLparam)},;
                   {WM_PAINT,;
                    WM_COMMAND,;
                    WM_SYSCOMMAND,;
                    WM_KEYDOWN,;
                    WM_CLOSE,;
                    WM_TIMER,;
                    WM_SIZE,;
                    WM_NCHITTEST,;
                    WM_SYSKEYDOWN})
RETURN(NIL)

STATIC FUNCTION MainWndBar
       LOCAL hDC        := GetDC(hMainWnd)
       LOCAL nOldBkClor := SetBkColor(hDC,RGB(192,192,192))
       LOCAL cPrompt    := ""
       LOCAL aCRect     := GetClientRect(hMainWnd)
       LOCAL nLeft      := 0
       LOCAL nTop       := aCRect[4]-26
       LOCAL nRight     := aCRect[3]
       LOCAL nBottom    := nTop+26

       MsgBar(hMainWnd)
       DrawText(hDC,cPrompt,;
               {22,nTop+5,nRight-180,nBottom-5},DT_LEFT+DT_SINGLELINE)
       SetBkColor(hDC,nOldBkClor)
       ReleaseDC(hMainWnd,hDC)
RETURN(NIL)

STATIC FUNCTION ToolBar
       LOCAL hInst := _GetInstance()
       LOCAL aRect := GetClientRect(hMainWnd)
       LOCAL nTop  := ((nTH+8)/2)-12
       LOCAL nCtr

       hToolBar    := CreateWindow("TB","",WS_CHILD+WS_VISIBLE+WS_BORDER,-2,-2,aRect[W_RIGHT]+3,;
                                   38,hMainWnd,0,hInst)
       HideCaret(hToolBar)
       DoSubClTB(hToolBar)
       aButtons[BTNLEFT  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,  5,nTop,36,36,hToolBar,IDLEFT,  hInst)
       aButtons[BTNRIGHT ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE, 42,nTop,36,36,hToolBar,IDRIGHT, hInst)
       aButtons[BTNUP    ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE, 79,nTop,36,36,hToolBar,IDUP,    hInst)
       aButtons[BTNDOWN  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,116,nTop,36,36,hToolBar,IDDOWN,  hInst)
       aButtons[BTNPGUP  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,153,nTop,36,36,hToolBar,IDPGUP,  hInst)
       aButtons[BTNPGDN  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,190,nTop,36,36,hToolBar,IDPGDN,  hInst)
       aButtons[BTNHOME  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,227,nTop,36,36,hToolBar,IDHOME,  hInst)
       aButtons[BTNEND   ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,264,nTop,36,36,hToolBar,IDEND,   hInst)
       aButtons[BTNTOP   ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,301,nTop,36,36,hToolBar,IDTOP,   hInst)
       aButtons[BTNBOTTOM] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,338,nTop,36,36,hToolBar,IDBOTTOM,hInst)
       aButtons[BTNFONT  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,375,nTop,36,36,hToolBar,IDFONT,  hInst)
       aButtons[BTNEDIT  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,412,nTop,36,36,hToolBar,IDEDIT,  hInst)
       aButtons[BTNDEL   ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,449,nTop,36,36,hToolBar,IDDEL,   hInst)
       aButtons[BTNREF   ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,486,nTop,36,36,hToolBar,IDREFALL,hInst)
       aButtons[BTNEXIT  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,560,nTop,36,36,hToolBar,IDBEXIT, hInst)
       aButtons[BTNHELP  ] := CreateWindow("BorBtn","",WS_CHILD+WS_VISIBLE,597,nTop,36,36,hToolBar,IDBHELP, hInst)
       FOR nCtr := 1 TO 16
           DoSubClBT(aButtons[nCtr])
       NEXT
RETURN(NIL)

STATIC FUNCTION SetButtons( lOffOn )
       LOCAL lFlag
       LOCAL nCtr

       lFlag := IIF(lBrowse,MF_GRAYED,MF_ENABLED)
       EnableMenuItem(hMenu,DEMO1,lFlag)
       EnableMenuItem(hMenu,DEMO2,lFlag)
       EnableMenuItem(hMenu,DEMO3,lFlag)
       EnableMenuItem(hMenu,DEMO4,lFlag)
       EnableMenuItem(hMenu,DEMO5,lFlag)
       EnableMenuItem(hMenu,DEMO6,lFlag)
       EnableMenuItem(hMenu,DEMO7,lFlag)
       EnableMenuItem(hMenu,DEMO8,lFlag)
       EnableMenuItem(hMenu,DEMO9,lFlag)
       EnableMenuItem(hMenu,IDORDER,lFlag)
       IF lOffOn != NIL
          FOR nCtr := 1 TO LEN( aButtons )
              EnableWindow( aButtons[ nCtr ], lOffOn )
          NEXT
       ENDIF
RETURN( NIL )

STATIC FUNCTION WndProcTB(nProc, hWnd, nMsg, nWparam, nLparam)
       LOCAL hBrush, nButton

       DO CASE
          CASE nMsg == WM_CTLCOLOR
               SetTextColor(nWparam, RGB(128,128,128))
               SetBkColor(nWparam, RGB(128,128,128))
               hBrush := GetStockObject(LTGRAY_BRUSH)
               RETURN(hBrush)

          CASE nMsg == WM_COMMAND
               PostMessage(hMainWnd,WM_COMMAND,nWparam,nLparam)
       ENDCASE
       SetFocus(hMainWnd)
RETURN(CallWindowProc(nProc, hWnd, nMsg, nWparam, nLparam))

STATIC FUNCTION DoSubClTB(hWnd)
       LOCAL nProc

       nProc := SubClassWindow(hWnd,                               ;
                   {|hWnd, nMsg, nWparam, nLparam|                 ;
                   WndProcTB(nProc, hWnd, nMsg, nWparam, nLparam)},;
                   {WM_CTLCOLOR,WM_COMMAND})
RETURN(NIL)

STATIC FUNCTION WndProcBW(nProc, hWnd, nMsg, nWparam, nLparam)

       IF nMsg == WM_KEYDOWN .AND. nWparam == VK_F1
          PostMessage(hMainWnd,nMsg,nWparam,nLparam)
       ENDIF
RETURN(CallWindowProc(nProc, hWnd, nMsg, nWparam, nLparam))

STATIC FUNCTION DoSubClBW(hWnd)
       LOCAL nProc

       nProc := SubClassWindow(hWnd,                               ;
                   {|hWnd, nMsg, nWparam, nLparam|                 ;
                   WndProcBW(nProc, hWnd, nMsg, nWparam, nLparam)},;
                   {WM_KEYDOWN})
RETURN(NIL)

STATIC FUNCTION WndProcBT(nProc, hWnd, nMsg, nWparam, nLparam)
       LOCAL cMsg , nCtr

       IF lBPrompt
          IF nMsg == WM_NCHITTEST
             nCtr := ASCAN(aButtons, hWnd)
             IF aBtnMsgs[nCtr] != cBtnMsg
                Message(hMainWnd,aBtnMsgs[nCtr])
                cBtnMsg := aBtnMsgs[nCtr]
                lBtnMsg := .T.
             ENDIF
          ENDIF
       ENDIF
RETURN(CallWindowProc(nProc, hWnd, nMsg, nWparam, nLparam))

STATIC FUNCTION DoSubClBT(hWnd)
       LOCAL nProc

       nProc := SubClassWindow(hWnd,                               ;
                   {|hWnd, nMsg, nWparam, nLparam|                 ;
                   WndProcBT(nProc, hWnd, nMsg, nWparam, nLparam)},;
                   {WM_NCHITTEST})
RETURN(NIL)

STATIC FUNCTION About

       DialogBox(_GetInstance() , "about", hMainWnd, ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                 MAbout(hDlg, nMsg, nWparam, nLparam)})
RETURN(NIL)

STATIC FUNCTION MAbout(hDlgWnd, nMsg, nWparam, nLparam)

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow(hDlgWnd)
               RETURN(1)

          CASE nMsg == WM_COMMAND
               EndDialog(hDlgWnd,IDNO)
               RETURN(1)
       ENDCASE
RETURN(0)

STATIC FUNCTION FindKid( oB )
       LOCAL nAnswer, cKid := "", nCrec

       nAnswer := DialogBox(_GetInstance() , "find", oB:hWnd , ;
                            {|hDlg, nMsg, nWparam, nLparam|;
                            MFind(hDlg, nMsg, nWparam, nLparam,oB, @cKid)})
       IF nAnswer == IDOK
          IF !EMPTY(cKid)
             SELECT CHILD
             nCrec := RECNO()
             SEEK cKid
             IF !FOUND()
                ErrorMsg(hMainWnd,"NOT FOUND!",'E')
                GOTO nCrec
             ELSE
                oB:rowPos    := 1
                oB:nCrecNo   := RECNO()
                oB:nCurRec   := NtxPos(INDEXORD(), RECNO())
                oB:hitTop    := BOF()
                oB:hitBottom := EOF()
                oB:showData()
             ENDIF
          ENDIF
       ENDIF
RETURN(NIL)

STATIC FUNCTION MFind( hDlgWnd, nMsg, nWparam, nLparam,oB, cKid )

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK
                       cKid := GetDlgItmText( hDlgWnd, 101 )
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION AddKid( oB, nMode )
       LOCAL nCrec , nAnswer

       SELECT CHILD
       IF nMode == 1
          nCrec := RECNO()
          GO BOTTOM
          SKIP
       ENDIF
       TmpVals()
       nAnswer := DialogBox( _GetInstance() , "addkid", oB:hWnd , ;
                            {|hDlg, nMsg, nWparam, nLparam|;
                            MAddKid( hDlg, nMsg, nWparam, nLparam, oB, nMode )})

       IF nAnswer == IDSAVE
          IF nMode == 1
             SELECT CHILD
             APPEND BLANK
             KidRepls()
             oB:goTop()
          ELSE
             KidRepls()
             oB:refreshAll()
          ENDIF
       ENDIF
RETURN(NIL)

STATIC FUNCTION MAddKid( hDlgWnd, nMsg, nWparam, nLparam, oB, nMode )
       STATIC GetList

       DO CASE
          CASE nMsg == WM_INITDIALOG
               GetList := KidGets( hDlgWnd )
               IF nMode == 2
                  CheckDlgButton( hDlgWnd, 106, IIF( SSEX  == 'M', 1, 0 ))
                  CheckDlgButton( hDlgWnd, 107, IIF( SSEX  == 'F', 1, 0 ))
                  CheckDlgButton( hDlgWnd, 108, IIF( SRACE == 'W', 1, 0 ))
                  CheckDlgButton( hDlgWnd, 109, IIF( SRACE == 'B', 1, 0 ))
                  CheckDlgButton( hDlgWnd, 110, IIF( SRACE == 'O', 1, 0 ))
               ENDIF
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDSAVE
                       IF IsDialogOk( hDlgWnd, IDSAVE )
                          SNOTES := GetDlgItmText( hDlgWnd, 111 )
                          EndDialog( hDlgWnd, IDSAVE )
                       ENDIF
                       RETURN(1)

                  CASE nWparam == IDCANCEL
                       CANCEL DIALOG hDlgWnd
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)

                  CASE nWparam >= 106 .AND. nWparam <= 107
                       SSEX := IIF( nWparam == 106,'M','F' )
                       RETURN(1)

                  CASE nWparam >= 108 .AND. nWparam <= 110
                       SRACE := IIF( nWparam == 108, 'W',;
                                    IIF( nWparam == 109, 'B', 'O'))
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION KidGets( hDlgWnd )
       LOCAL GetList := {}

       @ DIALOG hDlgWnd ID 101 GET SLAST_NAME
       @ DIALOG hDlgWnd ID 102 GET SFIRST_NAME
       @ DIALOG hDlgWnd ID 103 GET SMI
       @ DIALOG hDlgWnd ID 104 GET SJR_SR_III
       @ DIALOG hDlgWnd ID 105 GET SCCODE PICTURE "@!"
RETURN(GetList)

STATIC FUNCTION TmpVals

       SCCODE      := CHILD->CCODE
       SLAST_NAME  := CHILD->LAST_NAME
       SFIRST_NAME := CHILD->FIRST_NAME
       SMI         := CHILD->MI
       SJR_SR_III  := CHILD->JR_SR_III
       SRACE       := CHILD->RACE
       SSEX        := CHILD->SEX
       SNOTES      := CHILD->NOTES
RETURN(NIL)

STATIC FUNCTION KidRepls

       CHILD->CCODE      := SCCODE
       CHILD->LAST_NAME  := SLAST_NAME
       CHILD->FIRST_NAME := SFIRST_NAME
       CHILD->MI         := SMI
       CHILD->JR_SR_III  := SJR_SR_III
       CHILD->RACE       := SRACE
       CHILD->SEX        := SSEX
       CHILD->NOTES      := SNOTES
       COMMIT
RETURN(NIL)

STATIC FUNCTION QueBrowse( oB, lOnOff )

       IF oB != NIL
          DoSubClBW( oB:hWnd )
          AADD(aObjs, oB )
       ELSE
          AADD(aObjs,0)
       ENDIF
       lBrowse := .T.
       SetButtons( lOnOff )
RETURN(NIL)

STATIC FUNCTION UnQueBrow( lOnOff )

       aObjs   := {}
       lBrowse := .F.
       SetButtons( .T. )
RETURN(NIL)

STATIC FUNCTION ViewNotes( oB )

       DialogBox(_GetInstance() , "notes", oB:hWnd , ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                  MNotes( hDlg, nMsg, nWparam, nLparam, oB )})
RETURN(NIL)

STATIC FUNCTION MNotes(hDlgWnd, nMsg, nWparam, nLparam, oB)

       DO CASE
          CASE nMsg == WM_INITDIALOG
               SetDlgItemText( hDlgWnd, 101, LEFT(CHILD->NOTES,1400) )
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK
                       CHILD->NOTES := LEFT( GetDlgItmText( hDlgWnd, 101), 1400)
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION GetNewFont
       LOCAL aFont := {10, 0, 0, 0, 0, .F., .F., .F., 1, 0, 0, 0, 0, "Arial"}
       LOCAL hFont
       LOCAL nColor := RGB(0,0,0)

       aFont := ChooseFont( aFont,,, @nColor )
       IF aFont != NIL
          hFont := CreateFont( aFont )
       ENDIF
RETURN(hFont)

STATIC FUNCTION SubClassLB( hWnd, oB )
       LOCAL nProc

       nProc := SubClassWindow(hWnd,;
                   {|hWnd, nMsg, nWparam, nLparam| ;
                   WndProcLB( nProc, hWnd, nMsg, nWparam, nLparam, oB )},;
                   {WM_KEYDOWN,WM_SYSKEYDOWN})
RETURN(NIL)

STATIC FUNCTION WndProcLB( nProc, hWnd, nMsg, nWparam, nLparam, oB )

       IF nMsg == WM_KEYDOWN .OR. nMsg == WM_SYSKEYDOWN
          PostMessage( oB:hWnd, nMsg, nWparam, nLparam )
       ENDIF
RETURN(NIL)

STATIC FUNCTION MakeName
       LOCAL cTmpname

       cTmpname := TRIM(FIELD->LAST_NAME)+', '+;
                   TRIM(FIELD->FIRST_NAME)+' '+;
                   IIF(!EMPTY(FIELD->MI),FIELD->MI+'.','')+;
                   IIF(!EMPTY(FIELD->JR_SR_III),' ','')+FIELD->JR_SR_III
       cTmpname := LEFT(cTmpname+SPACE(35),35)
       IF ALLTRIM(cTmpname) == ','
          cTmpname := SPACE(35)
       ENDIF
RETURN(cTmpname)

STATIC FUNCTION GetWindowRect(hWnd)
       LOCAL cGWR
       LOCAL cBuf := space(8)
       LOCAL hLib := LoadLibrary("USER.EXE")

       cGWR := GetProcAddress(hLib, "GetWindowRect", ;
                              "Pascal", "void", "HWND, string")
       CallDLL(cGWR, hWnd, @cBuf)
       FreeLibrary(hLib)
RETURN(Bin2A(cBuf, "int[4]"))

STATIC FUNCTION KillNotePad
       LOCAL hWnd := FindWindow( "Notepad" )

       IF hWnd != 0
          PostMessage( hWnd, WM_CLOSE, 0, 0 )
       ENDIF
RETURN(NIL)

STATIC FUNCTION MCalc( hDlgWnd, nMsg, nWparam, nLparam, aBArray, oB )
       LOCAL aMoney

       DO CASE
          CASE nMsg == WM_INITDIALOG
               aMoney := ReCalc( aBArray )
               SetDlgItemText( hDlgWnd, 101, TRANSFORM(aMoney[1],"$99,999.99") )
               SetDlgItemText( hDlgWnd, 102, TRANSFORM(aMoney[2],"$99,999.99") )
               CenterWindow( hDlgWnd )
               SetFocus( oB:hWnd )
               RETURN(1)

          CASE nMsg == WM_MOVE
               SetFocus( oB:hWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK
                       DestroyWindow( hDlgWnd )
                       oB:Destroy()
                       RETURN(1)

                  CASE nWparam == IDCALC
                       aMoney := ReCalc( aBArray )
                       SetDlgItemText( hDlgWnd, 101, TRANSFORM(aMoney[1],"$99,999.99") )
                       SetDlgItemText( hDlgWnd, 102, TRANSFORM(aMoney[2],"$99,999.99") )
                       SetFocus( oB:hWnd )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION ReCalc( aArray )
       LOCAL nTuit := 0, nDisc := 0
       LOCAL nCtr

       FOR nCtr := 1 TO LEN(aArray)
           nTuit += aArray[nCtr][2]
           nDisc += IIF(aArray[nCtr][3] != 0,;
                        aArray[nCtr][2] * (aArray[nCtr][3]/100),0)
       NEXT
RETURN({nTuit,nDisc})

STATIC FUNCTION CellEdit( oB, nRecNo, nMode )
       LOCAL xKeyVal := IIF( EMPTY( INDEXKEY() ), NIL, &( INDEXKEY()))
       LOCAL xData, cPicture
       LOCAL nResults

       nMode := IIF( nMode == NIL, 0, nMode )

       IF nMode == IDDEL
          IF MessageBox( hMainWnd, "Delete Selected Record?",;
                         "Delete?", MB_YESNO+MB_ICONQUESTION ) == IDYES
             DELETE
             oB:refreshAll()
          ENDIF
          RETURN(1)
       ENDIF
       SELECT CHILD
       IF oB:colPos == 5
          ListBEdit( oB )
          RETURN(NIL)
       ENDIF
       DO CASE
          CASE oB:colPos == 1
                  xData    := CHILD->CCODE
                  cPicture := "@!"
          CASE oB:colPos == 2
                  xData := CHILD->LAST_NAME
          CASE oB:colPos == 3
                  xData := CHILD->FIRST_NAME
          CASE oB:colPos == 4
                  xData := CHILD->BIRTHDAY
          CASE oB:colPos == 5
                  ListBEdit( oB )
          CASE oB:colPos == 6
                  ViewNotes( oB )
       ENDCASE
       IF oB:colPos < 5
          nResults := DialogBox( _GetInstance() , "foo", oB:hWnd, ;
                       {|hDlg, nMsg, nWparam, nLparam|;
                       MFoo( hDlg, nMsg, nWparam, nLparam,oB,@xData, cPicture) })
          SetFocus( oB:hWnd )
          IF nResults == IDOK
             DO CASE
                CASE oB:colPos == 1
                     CHILD->CCODE := xData
                CASE oB:colPos == 2
                     CHILD->LAST_NAME := xData
                CASE oB:colPos == 3
                     CHILD->FIRST_NAME := xData
                CASE oB:colPos == 4
                     CHILD->BIRTHDAY := xData
             ENDCASE
             COMMIT
             IF EMPTY( INDEXKEY() ) .OR. ( xKeyVal == &( INDEXKEY() ) )
                 // make sure browse is correctly updated
                 oB:refreshCurrent()
             ELSE
                 // record may have moved relative to other records
                 oB:refreshAll()
             ENDIF
          ELSE
             oB:refreshCurrent()
          ENDIF
          SetFocus( oB:hWnd )
       ENDIF
RETURN(NIL)

STATIC FUNCTION MFoo( hDlgWnd, nMsg, nWparam, nLparam, oB, xData, cPicture )
       STATIC GetList
       LOCAL  aCell   := oB:CellRect()
       LOCAL  nLeft,nTop,nWidth,nHeight

       DO CASE
          CASE nMsg == WM_INITDIALOG
               Ctl3DUnRegister( _GetInstance() )
               GetList := {}
               nLeft   := aCell[1]
               nTop    := aCell[2]
               nWidth  := aCell[3]
               nHeight := aCell[4]
               nWidth  := PosEditWin( oB, hDlgWnd )
                IF oB:GetFont() == NIL
                   @ DIALOG hDlgWnd ID 101 GET xData PICTURE IIF(cPicture != NIL,cPicture,"")
                ELSE
                   @ DIALOG hDlgWnd ID 101 GET xData PICTURE IIF(cPicture != NIL,cPicture,"") FONT oB:GetFont()
                ENDIF
                RETURN(1)

           CASE nMsg == WM_COMMAND
                DO CASE
                   CASE nWparam == IDOK
                        IF IsDialogOk( hDlgWnd, 101 )
                           xData:= GetList[1]:VarGet()
                           Ctl3DRegister( _GetInstance() )
                           Ctl3DAutoSubClass( _GetInstance() )
                           SetFocus( hMainWnd )
                           EndDialog( hDlgWnd,IDOK )
                        ENDIF
                        RETURN(1)

                  CASE nWparam == IDCANCEL
                       CANCEL DIALOG hDlgWnd
                       Ctl3DRegister( _GetInstance() )
                       Ctl3DAutoSubClass( _GetInstance() )
                       SetFocus( hMainWnd )
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)
               ENDCASE
        ENDCASE
RETURN(0)

STATIC PROCEDURE Ctl3dRegister( hInst )
       LOCAL   cDLL := GetProcAddress( hCTL3D, "Ctl3dRegister", "Pascal",   ;
                                       "void", "int" )
       CallDLL( cDLL, hInst )
RETURN

STATIC PROCEDURE Ctl3dAutoSubclass( hInst )
       LOCAL   cDLL := GetProcAddress( hCTL3D, "Ctl3dAutoSubclass", "Pascal",   ;
                                       "void", "int" )
       CallDLL( cDLL, hInst )
RETURN

STATIC PROCEDURE Ctl3dUnregister( hInst )
       LOCAL   cDLL := GetProcAddress( hCtl3d, "Ctl3dUnregister", "Pascal",   ;
                                       "void", "int" )
       CallDLL( cDLL, hInst )
RETURN

STATIC FUNCTION GetActiveBrowse( hWnd )
       LOCAL nCtr

       FOR nCtr := 1 TO LEN(aObjs)
           IF aObjs[nCtr] != NIL
              RETURN( aObjs[nCtr] )
           ENDIF
       NEXT
RETURN(NIL)

STATIC FUNCTION CellAEdit( oB, nRecNo, nMode, aArray )
       LOCAL xData, cPicture
       LOCAL nResults := 0

       nMode := IIF( nMode == NIL, 0, nMode )
       IF nMode == IDDEL
          ErrorMsg( hMainWnd, "DELETIONS NOT ALLOWED!", 'E' )
          RETURN(NIL)
       ENDIF
       KillNotePad()
       SELECT CHILD
       DO CASE
          CASE oB:colPos == 1
               ErrorMsg( hMainWnd, "NAME CANNOT BE EDITED!", 'E' )
               RETURN(NIL)

          CASE oB:colPos == 2
                  xData    := aArray[oB:nCurRec][2]
                  cPicture := "999.99"
          CASE oB:colPos == 3
                  xData    := aArray[oB:nCurRec][3]
                  cPicture := "999.99"
          CASE oB:colPos == 4
               MemoEdit2( oB, aArray )
       ENDCASE

       IF oB:colPos != 4
          nResults := DialogBox( _GetInstance() , "foo", oB:hWnd, ;
                         {|hDlg, nMsg, nWparam, nLparam|;
                         MFoo( hDlg, nMsg, nWparam, nLparam, oB, @xData, cPicture ) })
       ENDIF
       IF nResults == IDOK
          SetFocus( oB:hWnd )
          DO CASE
             CASE oB:colPos == 2
                  aArray[oB:nCurRec][2] := xData
             CASE oB:colPos == 3
                  aArray[oB:nCurRec][3] := xData
          ENDCASE
       ENDIF
       IF oB:colPos != 4
          oB:refreshCurrent()
          SetFocus( oB:hWnd )
       ENDIF
RETURN(NIL)

STATIC FUNCTION MemoEdit2( oB, aArray )
       LOCAL nFp1, cBuffer

       IF !FILE( aArray[oB:nCurRec][4] )
          nFp1    := FCREATE( aArray[oB:nCurRec][4] )
          cBuffer := "NOTES:  "+aArray[oB:nCurRec ][1]
          FWRITE( nFp1, cBuffer, LEN(cBuffer) )
          FCLOSE( nFp1 )
       ENDIF
       SelectWindow( oB:hWnd )
       WINEXEC( "NOTEPAD.EXE "+aArray[oB:nCurRec][4] )
RETURN(NIL)


FUNCTION GetRDD( cNRDD )
       LOCAL nAnswer

       cRDD    := "DBFNTX"
       Message( hMainWnd, "Please select the RDD to use...")
       nAnswer := DialogBox( _GetInstance() , "rdd", ,  ;
                            {|hDlg, nMsg, nWparam, nLparam|;
                            MRDD( hDlg, nMsg, nWparam, nLparam )})
       Message( hMainWnd, "" )
       IF nAnswer == IDOK
          cNRDD := cRDD
       ENDIF
RETURN(( nAnswer == IDOK ))

STATIC FUNCTION MRDD( hDlgWnd, nMsg, nWparam, nLparam, cNRDD )
       LOCAL aRDDs := {"DBFNTX","DBFCDX","DBFNDX","DBFMDX"}

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow( hDlgWnd )
               CheckDlgButton( hDlgWnd, 101, 1 )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)

                  CASE nWparam == IDOK
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam >= 101 .AND. nWparam <= 104
                       cRDD := aRDDs[nWparam - 100]
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION ListBEdit( oB )
       LOCAL nResults

       USE RATES NEW VIA "DBFNTX"
       oB:lNoPaint := .T.
       EnableWindow( aButtons[BTNEXIT], .F. )
       nResults := DialogBox( _GetInstance() , "foolb", oB:hWnd, ;
                   {|hDlg, nMsg, nWparam, nLparam|;
                   MFooLB( hDlg, nMsg, nWparam, nLparam, oB )})
       SELECT CHILD
       oB:refreshAll()
       SetFocus( oB:hWnd )
       CLOSE RATES
       EnableWindow( aButtons[BTNEXIT], .T. )
       oB:lNoPaint := .F.
RETURN(NIL)

STATIC FUNCTION MFooLB( hDlgWnd, nMsg, nWparam, nLparam, oB )
       LOCAL  aCell   := oB:CellRect()
       LOCAL  nLeft,nTop,nWidth,nHeight
       LOCAL  aRates := {}

       DO CASE
          CASE nMsg == WM_INITDIALOG
               Ctl3DUnRegister( _GetInstance() )
               nLeft   := aCell[1]
               nTop    := aCell[2] - 1
               nWidth  := aCell[3]
               nHeight := aCell[4]
               SELECT RATES
               LoadListBox( GetDlgItem( hDlgWnd, 101 ),{||RATES->RATE_CODE+'-'+RATES->DESCRIPT})
               PosLBWin( hDlgWnd, nLeft, nTop, nWidth, nHeight )
               Message( hMainWnd, "Use Up/Down cursor keys to highlight, Enter key to select..." )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK
                       Ctl3DRegister( _GetInstance() )
                       Ctl3DAutoSubClass( _GetInstance() )
                       CHILD->RATE_CODE := LBGetSelection( GetDlgItem( hDlgWnd, 101 ) )
                       Message( hMainWnd, "" )
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam == IDCANCEL
                       Ctl3DRegister( _GetInstance() )
                       Ctl3DAutoSubClass( _GetInstance() )
                       Message( hMainWnd, "" )
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)
               ENDCASE
        ENDCASE
RETURN(0)

STATIC FUNCTION PosLBWin( hDlgWnd, nLeft, nTop, nWidth, nHeight )
       LOCAL hWndParent
       LOCAL aParent[4]
       LOCAL aPoint[2]

       hWndParent := GetWindow( hDlgWnd, GW_OWNER )
       aParent    := GetClientRect( hWndParent )
       aPoint[1]  := nLeft + 1
       aPoint[2]  := nTop + IIF( hWndParent == hMainWnd, 36, 0 )
       aPoint[2]  := nTop
       ClienttoScreen( hWndParent, aPoint )
       IF (nWidth + aPoint[1]) > aParent[3]
          nWidth := (aParent[3] - aPoint[1])+(aPoint[1]-nLeft)
       ENDIF
       MoveWindow( hDlgWnd, aPoint[1], aPoint[2], nWidth, nHeight*6, .F. )
       MoveWindow( GetDlgItem( hDlgWnd, 101 ), 0, 0, nWidth, nHeight*6, .F. )
RETURN(NIL)

STATIC FUNCTION SetMenu( hWnd, hMenu )
       STATIC cSM
       LOCAL hLib := LoadLibrary( "USER.EXE" )
       LOCAL hRMenu

       IF cSM == NIL
          cSM := GetProcAddress( hLib, "SetMenu", "Pascal", ;
                                 "int", "int,int" )
       ENDIF
       hRMenu :=  CallDLL( cSM, hWnd, hMenu )
       FreeLibrary( hLib )
RETURN(hRMenu)

**************************  mover's

// Skipper() - This is the same skipblock function that WBrowse()
// uses internally.  It is provided here so you can see what
// is required in those you write yourself.  The difference
// between tbrowse() and WBrowse() is that the exported instance
// variable nCurRec must be set if the vertical scroll bar is
// to be updated correctly and we need to set our current
// record number (oB:nCrecNo).

STATIC FUNCTION Skipper( oB, nSkip )
       LOCAL nMoved := 0

       DBSKIP( nSkip )
       DO CASE
          CASE nSkip > 0
               IF !EOF()
                  nMoved := nSkip
               ELSE
                  // This is important since WBrowse() will decrement it
                  // by 1 automatically so if we hit EOF() the record
                  // number will be equal to LastRec() + 1.

                  oB:nCurRec := RECNO()
                  oB:nCrecNo := RECNO() - 1
               ENDIF

          CASE nSkip < 0
               IF !BOF()
                  nMoved := nSkip
               ELSE
                  // If we are at the first record then that is what
                  // the current record number should be.

                  oB:nCurRec := 1
                  oB:nCrecno := 1
               ENDIF
       ENDCASE
       // We did not hit top or bottom so we adjust oB:nCurRec
       // by the number of records moved.

       IF nMoved == nSkip
          oB:nCurRec := IIF(nMoved > 0, oB:nCurRec + nSkip,;
                                        oB:nCurRec - (NegToPos(nSkip)))

       // We need to keep track of the record number so if we move
       // it somewhere else we will be back on the right one the
       // next time the browse gets focus..

          oB:nCrecNo := RECNO()
       ENDIF

       // We MUST return the number moved so WBrowse() can compare it
       // to the number requested in order to set hittop/hitbottom.
RETURN(nMoved)

// Internal gotopblock and gobottomblock functions used by WBrowse()
//
STATIC FUNCTION BGoBottom( oB )

       GO BOTTOM
       oB:hitBottom := .T.
       oB:hitTop    := BOF()
       oB:rowPos    := oB:nMaxLines
       oB:nCurRec   := RECCOUNT()
       oB:nCrecNo   := RECNO()
       oB:nMaxRec   := oB:nCurRec
RETURN(NIL)

STATIC FUNCTION BGoTop( oB )

       GO TOP
       oB:hitTop    := .T.
       oB:hitBottom := EOF()
       oB:nCurRec   := 1
       oB:rowPos    := 1
       oB:nCrecNo   := RECNO()
RETURN(NIL)

// Internal first key search routine used by Wbrowse()
//
STATIC FUNCTION FirstKey( oB, cKey )
       LOCAL nCrec

       IF oB:nCrecNo == NIL
          RETURN(NIL)
       ENDIF
       IF INDEXORD() != 0
          nCrec := RECNO()
          SEEK cKey
          IF !FOUND()
             GOTO nCrec
             MessageBeep( MB_ICONEXCLAMATION )
          ELSE
             oB:nCurRec   := NtxPos( INDEXORD(), RECNO() )
             oB:nCrecNo   := RECNO()
             oB:rowpos    := 1
             oB:showData()
          ENDIF
       ENDIF
RETURN(NIL)

// SkipFor() - Special skipblock for handling sub-set browses.
//
STATIC FUNCTION SkipFor( oB, nSkip, bSearch, cKey )
       LOCAL nMoved := 0

       DBSKIP( nSkip )
       DO CASE
          CASE ( nSkip > 0 )
               IF EVAL(bSearch) != cKey
                  RETURN(-1)
               ENDIF
               nMoved := nSkip
               oB:nCurRec += nSkip

         CASE ( nSkip < 0 )
              IF EVAL(bSearch) != cKey
                 RETURN(0)
              ENDIF
              nMoved := nSkip
              oB:nCurRec := oB:nCurRec - NegToPos(nSkip)
       ENDCASE
       oB:nCrecNo := RECNO()
RETURN( nMoved )

// FindFirst() - Special goTopBlock for browsing sub-sets.
//
STATIC FUNCTION FindFirst( oB, cKey )

       SEEK cKey
       oB:nCrecNo   := RECNO()
       oB:hitTop    := .T.
       oB:hitBottom := .F.
       oB:rowPos    := 1
RETURN(NIL)

// FindLast() - Special goBottomBlock for browsing sub-sets.
//
STATIC FUNCTION FindLast( oB, bSearch, cKey )

       SEEK cKey
       DO WHILE EVAL(bSearch) == cKey  .AND. ! (EOF())
          SKIP
       ENDDO
       SKIP -1
       oB:hitBottom := .T.
       oB:hitTop    := .F.
       oB:nCrecNo   := RECNO()
       oB:rowPos    := oB:nMaxLines
RETURN(NIL)

// Array browse gotop routine
//
STATIC FUNCTION AGoTop( oB, aArray )

       oB:nCurRec   := 1
       oB:rowPos    := 1
       oB:nCrecNo   := 1
       oB:nMaxRec   := LEN(aArray)
       oB:hitTop    := .T.
       oB:hitBottom := .F.
RETURN(NIL)

// Array browse gobottom routine
//
STATIC FUNCTION AGoBottom( oB, aArray )

       oB:nCurRec   := LEN(aArray)
       oB:nMaxRec   := oB:nCurRec
       oB:rowPos    := oB:nMaxLines
       oB:nCrecNo   := oB:nCurRec
       oB:hitBottom := .T.
       oB:hitTop    := .F.
RETURN(NIL)

// Array browse skip routine
//
STATIC FUNCTION ASkipper( oB, nSkip, aArray )
       LOCAL nMoved := 0

       DO CASE
          CASE nSkip > 0
               IF ( oB:nCurRec + nSkip ) <= oB:nMaxRec
                  oB:nCurRec := oB:nCurRec + nSkip
                  nMoved := nSkip
                  oB:nCrecNo := oB:nCurRec
               ELSE
                  oB:nCurRec := oB:nMaxRec + 1 // IMPORTANT!  Must be
                                               // = to LASTREC() + 1
               ENDIF

          CASE nSkip < 0
               IF ( oB:nCurRec - NegToPos(nSkip) ) >= 1
                  oB:nCurRec := oB:nCurRec - NegToPos(nSkip)
                  nMoved     := nSkip
                  oB:nCrecNo := oB:nCurRec
               ELSE
                  oB:nCurRec := 1
                  oB:nCrecNo := 1
                  oB:hitTop  := .T.
               ENDIF
       ENDCASE
RETURN(nMoved)

// First key search routine for an array
//
STATIC FUNCTION AFindKey( oB, cKey, aArray )
       LOCAL nCtr

       FOR nCtr := 1 TO LEN(aArray)
           IF LEFT( UPPER(aArray[nCtr][1]) ,1 ) == cKey
              EVAL( oB:gotopBlock, oB )
              EVAL( oB:skipBlock, oB, nCtr-1 )
              oB:rowPos    := 1
              oB:showData()
              RETURN(.T.)
           ENDIF
       NEXT
RETURN(.F.)

*******************  Order Form

STATIC FUNCTION OrderForm
       LOCAL nAnswer, aOrder[20]

       nAnswer := DialogBox( _GetInstance(), "order", hMainWnd,;
                             {|hDlg, nMsg, nWparam, nLparam|;
                             MOrder( hDlg, nMsg, nWparam, nLparam, aOrder )})
       IF nAnswer == IDSAVE
          WriteOrder( aOrder )
       ENDIF
RETURN(NIL)

STATIC FUNCTION MOrder( hDlgWnd, nMsg, nWparam, nLparam, aOrder )
       STATIC nShip, nTax, nQty, nTotal
       LOCAL nCtr

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow( hDlgWnd )
               CheckDlgButton( hDlgWnd, 107, 1 )
               SetDlgItemText( hDlgWnd, 108, "1" )
               SetDlgItemText( hDlgWnd, 109, "$59.95" )
               SetDlgItemText( hDlgWnd, 110, "$0.00" )
               SetDlgItemText( hDlgWnd, 111, "$0.00" )
               SetDlgItemText( hDlgWnd, 112, "$59.95" )
               CheckDlgButton( hDlgWnd, 115, 1 )
               nShip  := 0.00
               nQty   := 1
               nTax   := 0.00
               nTotal := 59.95
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)

                  CASE nWparam == IDSAVE
                       IF IsDlgButtonChecked( hDlgWnd, 115 ) == 1
                          IF EMPTY( GetDlgItmText( hDlgWnd, 116 ) )
                             ErrorMsg( hDlgWnd, "CIS ID# BLANK!" , 'E' )
                             SetFocus( GetDlgItem( hDlgWnd, 116 ) )
                             RETURN(1)
                           ENDIF
                       ENDIF
                       FOR nCtr := 101 TO 105
                           aOrder[ nCtr - 100 ] := GetDlgItmText( hDlgWnd, nCtr )
                       NEXT
                       aOrder[06] := nQty
                       aOrder[07] := ( nQty * 59.95 )
                       aOrder[08] := aOrder[07] * nTax
                       aOrder[09] := nShip
                       aOrder[10] := nTotal
                       aOrder[11] := GetDlgItmText( hDlgWnd, 116 )
                       aOrder[12] := GetDlgItmText( hDlgWnd, 117 )
                       aOrder[13] := GetDlgItmText( hDlgWnd, 118 )
                       EndDialog( hDlgWnd, IDSAVE )
                       RETURN(1)

                  CASE nWparam >= 113 .AND. nWparam <= 115
                       DO CASE
                          CASE nWparam == 113
                               nShip := 2.90
                          CASE nWparam == 114
                               nShip := 5.80
                          CASE nWparam == 115
                               nShip := 0.00
                       ENDCASE
                       PostMessage( hDlgWnd, WM_COMMAND, WM_USER + 1, 0 )
                       RETURN(1)
                  CASE nWparam == 108
                       nQty := VAL( GetDlgItmText( hDlgWnd, 108 ) )
                       PostMessage( hDlgWnd, WM_COMMAND, WM_USER + 1, 0 )
                       RETURN(1)

                  CASE nWparam == 106
                       nTax := .05
                       PostMessage( hDlgWnd, WM_COMMAND, WM_USER + 1, 0 )
                       RETURN(1)
                  CASE nWparam == 107
                       nTax := .00
                       PostMessage( hDlgWnd, WM_COMMAND, WM_USER + 1, 0 )
                       RETURN(1)
                  CASE nWparam == WM_USER + 1
                       nTotal := ( nQty * 59.95 )
                       nTotal += ( nTotal * nTax)
                       nTotal += nShip
                       SetDlgItemText( hDlgWnd, 112,;
                                       '$'+LTRIM(TRANSFORM( nTotal, "9999.99" ) ) )
                       SetDlgItemText( hDlgWnd, 109, '$'+LTRIM(TRANSFORM( ( nQty * 59.95 ), "9999.99" ) ) )
                       SetDlgItemText( hDlgWnd, 110, '$'+LTRIM(TRANSFORM( ( nQty * 59.95) * nTax, "9999.99") ) )
                       SetDlgItemText( hDlgWnd, 111, '$'+LTRIM(TRANSFORM( nShip, "9999.99" ) ) )
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION WriteOrder(aOrder)
       LOCAL nFp1, cBuffer, cCrLf := CHR(13)+CHR(10), nShip := aOrder[09]

       nFp1    := FCREATE( "ORDER.TXT" )
       cBuffer := SPACE(20)+"     Logical Systems     " + cCrLf +;
                  SPACE(20)+"  2635 Portsmouth Place  " + cCrlf +;
                  SPACE(20)+"Hephzibah, GA 30815 (USA)" + cCrLf +;
                  SPACE(20)+" (706) 790-7303 (VOICE)  " + cCrLf +;
                  SPACE(20)+"  (706) 790-7084 (FAX)   " + cCrLf + cCrLf +;
                  SPACE(20)+"  WBrowse(s) Order Form  "
       FWRITE( nFp1, cBuffer, LEN(cBuffer) )
       cBuffer := cCrlf
       FWRITE( nFp1, cBuffer, LEN(cBuffer) )
       cBuffer := cCrlf
       FWRITE( nFp1, cBuffer, LEN(cBuffer) )
       cBuffer := "Ship To:  "+aOrder[1] + cCrlf +;
                  "          "+aOrder[2] + cCrlf +;
                  "          "+aOrder[3] + cCrlf +;
                  "          "+aOrder[4] + cCrlf +;
                  "          "+aOrder[5] + cCrlf + cCrlf +;
                  "          "+aOrder[12] + cCrlf +;
                  "          "+aOrder[13] + cCrlF + cCrLf +;
                  "Ship Via:  "+IIF( nShip == 0, "CIS Mail", ;
                               IIF( nShip == 2.90, "US Mail", "International Mail")) + cCrLf +;
       IIF( nShip == 0, " CIS ID#:  "+aOrder[11],"")+ cCrLf + cCrLf +;
                  "              Order Details:" + cCrlF + cCrLf
       FWRITE( nFp1, cBuffer, LEN(cBuffer) )
       cBuffer := "        Qty:  "+LTRIM(STR(aOrder[6])) + cCrLf +;
                  "  Sub-Total:  "+'$'+LTRIM(TRANSFORM(aOrder[07],"9999.99")) + cCrLf +;
                  "  Sales Tax:  "+'$'+LTRIM(TRANSFORM(aOrder[08],"9999.99")) + cCrLf +;
                  "   Shipping:  "+'$'+LTRIM(TRANSFORM(aOrder[09],"9999.99")) + cCrLf +;
                  "      Total:  "+'$'+LTRIM(TRANSFORM(aOrder[10],"9999.99")) + cCrLf
       FWRITE( nFp1, cBuffer, LEN(cBuffer) )
       cBuffer := cCrLf + cCrLf + " Please include a check or money order payable in US Dollars "+ cCrLf +;
                                  " with your order.  Please make check or money order payable to:" +;
                  cCrLf + cCrLf + " Logical Systems" + cCrLf + cCrlf +;
                                  " Thank you for ordering WBrowse(s)"
       FWRITE( nFp1, cBuffer, LEN(cBuffer) )
       FCLOSE( nFp1 )
       WINEXEC( "NOTEPAD.EXE ORDER.TXT" )
RETURN(NIL)

STATIC FUNCTION StrValType(xData)
       LOCAL cVal := VALTYPE(xData)

       DO CASE
          CASE cVal == 'A'
               RETURN(cVal)
          CASE cVal == 'B'
               RETURN(cVal)
          CASE cVal == 'N'
               RETURN(LTRIM(STR(xData)))
          CASE cVal == 'L'
               RETURN(LTOC(xData))
          CASE cVal == 'C'
               RETURN(xData)
          CASE cVal == 'U'
               RETURN(cVal)
       ENDCASE
RETURN('U')

STATIC FUNCTION PosEditWin( oB, hDlgWnd )
       LOCAL aCell := oB:CellRect( 1 )
       LOCAL aPoint[2]
       LOCAL nWidth, nHeight

       nWidth    := aCell[3]
       nHeight   := aCell[4]
       aPoint[1] := aCell[1]
       aPoint[2] := aCell[2]
       ClienttoScreen(oB:hWnd,aPoint)
       MoveWindow(hDlgWnd,aPoint[1],aPoint[2],nWidth,nHeight,.F.)
       MoveWindow(GetDlgItem(hDlgWnd,101),4,1,nWidth-4,nHeight,.F.)
RETURN(NIL)

STATIC FUNCTION BrowEnd( oB )
       LOCAL nCtr

       FOR nCtr := 1 TO LEN( oB:cargo )
           IF oB:cargo[ nCtr ][ 1 ] != NIL
              DestroyWindow( oB:cargo[ nCtr ][ 1 ] )
           ENDIF
       NEXT
       UnQueBrow(.T.)
RETURN( NIL )

STATIC FUNCTION DrawButtons( hWnd, aButtons, oB, lFind )
       LOCAL nCtr, aCrect, nRight, hTB, hBWnd, hInst

       aCrect   := GetClientRect( hWnd )
       hInst    := _GetInstance()
       hTB      := CreateWindow("TB","",WS_CHILD+WS_VISIBLE+WS_BORDER,-2,-2,aCRect[W_RIGHT]+3,;
                                 TextHeight( hWnd)+11,hWnd,0, hInst)
       HideCaret(hTB)
       DoSubClSB( hTB, hWnd )
       aButtons := {}
       AADD(aButtons, { hTB, NIL, NIL })
       nRight := 2
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDTOPS, hInst),;
                          IDTOPS, {|oB|oB:GoTop(.F.)} } )

       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDBOTTOMS, hInst),;
                          IDBOTTOMS, {|oB|oB:GoBottom(.F.)} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDPGUPS, hInst),;
                          IDPGUPS, {|oB|oB:PageUp()} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDPGDNS, hInst),;
                          IDPGDNS, {|oB|oB:PageDown()} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDALTHOME, hInst),;
                          IDALTHOME, {|oB|oB:Home()} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDALTEND, hInst),;
                          IDALTEND, {|oB|oB:End()} } )
       nRight += 52
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDADDS, hInst),;
                          IDADDS, {|oB|AddKid( oB, 1 )} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDDELETES, hInst),;
                          IDDELETES, {|oB|CellEdit( oB, 1, IDDEL )} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDEDITS, hInst),;
                          IDEDITS, {|oB|AddKid( oB, 2 )} } )
       IF lFind
          nRight += 26
          AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                             nRight,1,25,22,hTB, IDFINDS, hInst),;
                             IDFINDS, {|oB|FindKid( oB ), SetFocus( hWnd )} } )
       ENDIF
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDPRINTS, hInst),;
                          IDPRINTS, {|oB|Print( hWnd, oB )} } )
       nRight += 52
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDEXITS, hInst),;
                          IDEXITS, {|oB|DestroyWindow( hWnd )} } )
       nRight += 26
       AADD( aButtons,  { CreateWindow("borbtn","",WS_CHILD+WS_VISIBLE,;
                          nRight,1,25,22,hTB, IDBHELPS, hInst),;
                          IDBHELPS, {|oB|BHelp()} } )
RETURN( aButtons )

STATIC FUNCTION BDoSubCl( hWnd, oB )
       LOCAL nProc

       nProc := SubClassWindow(hWnd,;
                   {|hWnd, nMsg, nWparam, nLparam| ;
                   BWndProc(nProc, hWnd, nMsg, nWparam, nLparam, oB)},;
                   {WM_PAINT,;
                    WM_COMMAND,;
                    WM_SYSCOMMAND,;
                    WM_KEYDOWN,;
                    WM_DESTROY,;
                    WM_CLOSE,;
                    WM_TIMER,;
                    WM_SIZE,;
                    WM_NCHITTEST,;
                    WM_SYSKEYDOWN})
RETURN(NIL)

STATIC FUNCTION BWndProc( nProc, hWnd, nMsg, nwParam, nlParam, oB )
       LOCAL nCtr, hFont, aCRect, nTop, nBottom, hBrowWnd

       hBrowWnd := oB:hWNd
       DO CASE
          CASE nMsg == WM_SYSCOMMAND
               IF nWparam == SC_CLOSE
                  DestroyWind( hWnd )
               ENDIF

          CASE nMsg == WM_DESTROY
               FOR nCtr := 1 TO LEN( oB:cargo )
                   IF oB:cargo[ nCtr ][ 1 ] != NIL
                      DestroyWindow( oB:cargo[ nCtr ][ 1 ] )
                   ENDIF
               NEXT

          CASE nMsg == WM_PAINT
               MsgBar( hWnd )
               IF oB:selectBlock != NIL
                  EVAL( oB:selectBlock, oB )
               ENDIF

          CASE nMsg == WM_SIZE
               IF nWparam != SIZE_MINIMIZED
                  aCRect  := GetClientRect( hWnd )
                  nTH     := TextHeight( hWnd )
                  nTop    := nTH+9
                  nBottom := aCRect[ 4 ] - ( nTop + ( nTH+10 ) )
                  MoveWindow( oB:hWnd,1,nTop,aCRect[3],nBottom,.T.)
                  MoveWindow( oB:cargo[1][1], -2, -2, aCRect[W_RIGHT]+3, nTH+11, .T. )
                  SendMessage( oB:hWnd, WM_PAINT, 0 , 0 )
               ENDIF

          CASE nMsg == WM_KEYDOWN .OR. nMsg == WM_SYSKEYDOWN
               PostMessage( hBrowWnd, nMsg, nWparam, nLparam )

          CASE nMsg == WM_COMMAND
               FOR nCtr := 1 TO LEN( oB:cargo )
                   IF oB:cargo[ nCtr ][ 2 ] == nWparam
                      IF oB:cargo[ nCtr ][ 3 ] != NIL
                         EVAL( oB:cargo[ nCtr ][ 3 ], oB )
                      ENDIF
                      EXIT
                   ENDIF
               NEXT
       ENDCASE
       IF IsWindow( hWnd )
          SetFocus( hWnd )
       ELSE
          SetFocus( hMainWnd )
       ENDIF
RETURN(CallWindowProc(nProc, hWnd, nMsg, nWparam, nLparam))

STATIC FUNCTION WndProcSB(nProc, hWnd, nMsg, nWparam, nLparam, hBWnd)
       LOCAL hBrush, nButton

       DO CASE
          CASE nMsg == WM_CTLCOLOR
               SetTextColor(nWparam, RGB(128,128,128))
               SetBkColor(nWparam, RGB(128,128,128))
               hBrush := GetStockObject(LTGRAY_BRUSH)
               RETURN(hBrush)

          CASE nMsg == WM_COMMAND
               PostMessage(hBWnd,WM_COMMAND,nWparam,nLparam)
       ENDCASE
RETURN(CallWindowProc(nProc, hWnd, nMsg, nWparam, nLparam))

STATIC FUNCTION DoSubClSB( hWnd , hBWnd)
       LOCAL nProc

       nProc := SubClassWindow(hWnd,                               ;
                   {|hWnd, nMsg, nWparam, nLparam|                 ;
                   WndProcSB(nProc, hWnd, nMsg, nWparam, nLparam, hBWnd)},;
                   {WM_CTLCOLOR,WM_COMMAND})
RETURN(NIL)

STATIC FUNCTION SetNubs( oB )
       LOCAL hDC := GetDC( oB:hWnd )
       LOCAL hOldFont, hBrowFont

       hBrowFont := oB:GetFont()
       IF hBrowFont != NIL
          hOldFont := SelectObject( hDC, hBrowFont )
       ENDIF
       oB:setColWidth(0,C4W_LoWord(GetTextExtent(hDC,"WWW0000",7)))
       IF hOldFont != NIL
          SelectObject( hDC, hOldFont )
       ENDIF
       ReleaseDC( oB:hWnd, hDC )
RETURN( NIL )

STATIC FUNCTION Print( hWnd, oB )
       LOCAL hPrintDC
       LOCAL hFont1, hFont2
       LOCAL nPtSize
       LOCAL aFont := {-19, 0, 0, 0, 0, .F., .F., .F., 1, 0, 0, 0, 0, "Arial"}

       // We let the user select the font and style
       // but we will set the size later!

       aFont    := ChooseFont(aFont)
       IF aFont == NIL
          RETURN( NIL )
       ENDIF

       // Let the user select the printer and set it up if needed...

       hPrintDC := GetPrintDC()
       IF EMPTY(hPrintDC)
          RETURN( NIL )
       ENDIF

       // Sometimes the printer setup dialog messes up our window
       // so to make things nice we will re-draw it....

       SendMessage( hWnd, WM_PAINT, 0, 0 )

       // Now we set our font sizes

       // 14 point for our heading

       nPtSize  := PosToNeg( ( 14 * GetDeviceCaps( hPrintDC, LOGPIXELSY ) ) / 72 )
       aFont[1] := nPtSize
       hFont1   := CreateFont( aFont )

       // 10 point for the details...

       nPtSize  := PosToNeg( ( 10 * GetDeviceCaps( hPrintDC, LOGPIXELSY ) ) / 72 )
       aFont[1] := nPtSize
       hFont2   := CreateFont( aFont )

       DialogBox( _GetInstance() , "statusbar", , ;
                  {|hDlg, nMsg, nWparam, nLparam|;
                  MPrint( hDlg, nMsg, nWparam, nLparam, hPrintDC, oB, hFont1, hFont2 ) } )

       // Clean up....

       DeleteObject( hFont1 )
       DeleteObject( hFont2 )
       DeleteDC(hPrintDC)
RETURN( NIL )

STATIC FUNCTION MPrint( hDlgWnd, nMsg, nWparam, nLparam, hPrintDC, oB, hFont1, hFont2 )
       STATIC hWnd, nRight, nBottom, hDC, hGBrush, lFirst, nCtr, lCancel
       STATIC aCols[7], hBPen4, hBPen2
       STATIC nWidth, nHeight, nPage, nTM, nTH, aTM, nBM
       LOCAL aCrect, nEvent, nLM

       DO CASE
          CASE nMsg == WM_INITDIALOG
               SendMessage( hDlgWnd, WM_SETTEXT, 0 , "Printing" )
               SetDlgItemText( hDlgWnd, 105, "Records Printed:")
               CenterWindow( hDlgWnd )
               hWnd     := GetDlgItem( hDlgWnd, 101 )
               aCRect   := GetClientRect( hWnd )
               nRight   := aCRect[ W_RIGHT ]
               nBottom  := aCRect[ W_BOTTOM ]
               hDC      := GetDC( hWnd )
               hGBrush  := CreateSolidBrush( RGB( 0, 255, 0 ) )
               hBPen2   := CreatePen(PS_SOLID,2,RGB(0,0,0))
               hBPen4   := CreatePen(PS_SOLID,4,RGB(0,0,0))
               nWidth   := GetDeviceCaps(hPrintDC, HORZRES)
               nHeight  := GetDeviceCaps(hPrintDC, VERTRES)
               lFirst   := .T.
               lCancel  := .F.

               // Figure out how wide to make our columns

               SelectObject( hPrintDC, hFont2 )
               aCols[1] := 0
               aCols[2] := aCols[1] + C4W_LoWord(GetTextExtent(hPrintDC,"BBB0000W",8))
               aCols[3] := aCols[2] + C4W_LoWord(GetTextExtent(hPrintDC,"WWWWWWWWWWWWWW",14))
               aCols[4] := aCols[3] + C4W_LoWord(GetTextExtent(hPrintDC,"WWWWWWWWWWWW",12))
               aCols[5] := aCols[4] + C4W_LoWord(GetTextExtent(hPrintDC,"00/00/00W",9))
               aCols[6] := aCols[5] + C4W_LoWord(GetTextExtent(hPrintDC,"FemaleW",7))
               aCols[7] := aCols[6] + C4W_LoWord(GetTextExtent(hPrintDC,"BlackW",6))

               // Center the report on the page

               nLM      := ( nWidth - aCols[7] ) / 2
               FOR nCtr := 1 TO 7
                   aCols[nCtr] += nLM
               NEXT
               nCtr     := 0
               aTM      := {}
               GetTextMetrics(hPrintDC,@aTM)
               nTH     := aTM[ TM_Height ]
               RETURN( 1 )

          CASE nMsg == WM_PAINT
               IF lFirst
                  lFirst := .F.
                  PostMessage( hDlgWnd, WM_USER+1, 0, 0 )
               ENDIF
               RETURN( 0 )

          CASE nMsg == WM_COMMAND
               IF nWparam == IDCANCEL
                  lCancel := .T.
               ENDIF
               RETURN( 0 )

          CASE nMsg == WM_USER+1
               SetFocus( GetDlgItem( hDlgWnd, 101) )
               SetDlgItemText( hDlgWnd, 102, LTRIM( STR( CHILD->( LASTREC())  ) ) )
               StatusBar( 0, CHILD->( LASTREC() ), hDlgWnd, nRight, nBottom, hDC, hGBrush, 0 )
               nPage      := 1
               nTM        := 200
               nBM        := nTM + ( nTH + ( nTH / 2 ) )
               DO WHILE .T.
                  IF nBM + ( nTH + ( nTH /2 ) ) > nHeight - 200
                     EXIT
                  ENDIF
                  nBM  += ( nTH + ( nTH /2 ) )
               ENDDO
               nBM  := C4W_Int( nBM - ( nTH /2 ) ) + 4
               CHILD->(DBGOTOP())
               StartDoc(hPrintDC, "Child List")
               StartPage(hPrintDC)
               Header( hPrintDC, hBPen4, hFont1, hFont2, nTM, nTH, nBM, nWidth, nPage, aCols )
               nTM += nTH + ( nTH / 2 )
               DO WHILE !EOF() .AND. !lCancel
                  IF ( nEvent := ChkEvent() ) == EVENT_BUTTON
                     HandleEvent( nEvent )
                  ENDIF
                  PrintLine( hPrintDC, nTM, aCols )
                  nTM += nTH + ( nTH / 2 )
                  CHILD->(DBSKIP( 1 ))
                  StatusBar( ++nCtr,NIL, hDlgWnd, nRight, nBottom, hDC, hGBrush, nCtr )
                  IF nTM > nBM
                     EndPage(hPrintDC)
                     StartPage(hPrintDC)
                     nTM := 200
                     ++nPage
                     Header( hPrintDC, hBPen4, hFont1, hFont2, nTM, nTH, nBM, nWidth, nPage, aCols )
                     nTM += nTH + ( nTH / 2 )
                  ELSE
                     SelectObject( hPrintDC, hBPen2 )
                     MoveTo( hPrintDC, aCols[1] - 10, nTM - ( ( nTH / 4 ) + 4 ) )
                     LineTo( hPrintDC, aCols[7], nTM - ( ( nTH /4 ) + 4 ) )
                  ENDIF
               ENDDO
               EndPage(hPrintDC)
               EndDoc(hPrintDC)
               StatusBar( CHILD->(LASTREC()), CHILD->(LASTREC()), hDlgWnd, nRight, nBottom, hDC, hGBrush, 0 )
               DeleteObject( hGBrush )
               DeleteObject( hBPen2 )
               DeleteObject( hBPen4 )
               ReleaseDC( hWnd, hDC )
               EndDialog( hDlgWnd, 0 )
               RETURN( 1 )
       ENDCASE
RETURN( 0 )

STATIC FUNCTION Header( hPrintDC, hBPen, hFont1, hFont2, nTM, nTH, nBM, nWidth, nPage, aCols )
       STATIC cPrinted

       // 05/23/94 GB -> Added for PostScript Compatibility
       LOCAL nOldMode

       // 05/23/94 GB -> Moved for PostScript Compatibility
       LOCAL hBrush :=  GetStockObject( LTGRAY_BRUSH )
       FillRect(hPrintDC, aCols[1] - 10, nTM - 12, aCols[7], nTM+nTH, hBrush)

       IF nPage == 1
          cPrinted := DTOC( DATE() ) + '-' + LEFT( TIME(), 5 )
       ENDIF

       SelectObject( hPrintDC, hFont1 )
       nOldMode := SetBkMode(hPrintDC, TRANSPARENT)
       // 05/23/94 GB -> Changed y coordinates for PostScript Printer
       DrawText( hPrintDC, "Child List",;
                { 0, 60, nWidth, 180 }, DT_CENTER+DT_SINGLELINE )
       SelectObject( hPrintDC, hFont2 )
       TextOut( hPrintDC, aCols[1] + 12, nTM, "ID#" )
       TextOut( hPrintDC, aCols[2] + 12, nTM, "LAST NAME" )
       TextOut( hPrintDC, aCols[3] + 12, nTM, "FIRST NAME" )
       TextOut( hPrintDC, aCols[4] + 12, nTM, "DOB" )
       TextOut( hPrintDC, aCols[5] + 12, nTM, "SEX" )
       TextOut( hPrintDC, aCols[6] + 12, nTM, "RACE" )
       SelectObject( hPrintDC, hBPen )

       MoveTo( hPrintDC, aCols[1] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[7], nTM - 12    )

       MoveTo( hPrintDC, aCols[1] - 10, nTM + nTH + 4 )
       LineTo( hPrintDC, aCols[7], nTM + nTH + 4 )

       MoveTo( hPrintDC, aCols[1] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[1] - 10, nBM )

       MoveTo( hPrintDC, aCols[2] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[2] - 10, nBM )

       MoveTo( hPrintDC, aCols[3] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[3] - 10, nBM )

       MoveTo( hPrintDC, aCols[4] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[4] - 10, nBM )

       MoveTo( hPrintDC, aCols[5] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[5] - 10, nBM )

       MoveTo( hPrintDC, aCols[6] - 10, nTM - 12 )
       LineTo( hPrintDC, aCols[6] - 10, nBM )

       MoveTo( hPrintDC, aCols[7], nTM - 12 )
       LineTo( hPrintDC, aCols[7], nBM )

       MoveTo( hPrintDC, aCols[1] - 10, nBM )
       LineTo( hPrintDC, aCols[7], nBM )

       TextOut( hPrintDC, aCols[1] - 10, nBM + 10, "Page:  "+LTRIM(STR(nPage)) )
       TextOut( hPrintDC, aCols[7] - C4W_LoWord(GetTextExtent(hPrintDC,cPrinted,LEN( cPrinted ))),;
                nBM + 10, cPrinted)

       // 05/23/94 GB -> Added for PostScript Compatibility
       SetBkMode(hPrintDC, nOldMode)
RETURN( NIL )

STATIC FUNCTION PrintLine( hPrintDC, nTM, aCols )

       TextOut( hPrintDC, aCols[1] + 12, nTM, FIELD->CCODE )
       TextOut( hPrintDC, aCols[2] + 12, nTM, FIELD->LAST_NAME )
       TextOut( hPrintDC, aCols[3] + 12, nTM, FIELD->FIRST_NAME )
       TextOut( hPrintDC, aCols[4] + 12, nTM, DTOC( FIELD->BIRTHDAY ) )
       TextOut( hPrintDC, aCols[5] + 12, nTM, IIF( FIELD->SEX == 'M', "Male", "Female" ) )
       TextOut( hPrintDC, aCols[6] + 12, nTM, IIF( FIELD->RACE == 'W', "White",;
                                              IIF( FIELD->RACE == 'B', "Black", "Other" ) ) )
RETURN( NIL )

STATIC FUNCTION StatusBar( nDone, nToDo, hWnd, nRight, nBottom, hDC, hBrush, nCopied )
       STATIC nTotalSize
       STATIC nPercent
       LOCAL  nReplicate
       LOCAL  cPercent

       IF nToDo != NIL
          nTotalSize :=  nToDo
          SetBkMode( hDC, 1 )
          nPercent := 0
       ENDIF
       IF nDone <= nTotalSize
          nReplicate := C4W_Int( ( nRight-2 ) * ( nDone / nTotalSize ) )
          IF nReplicate == nPercent
             RETURN(NIL)
          ENDIF
          nPercent := nReplicate
          IF nCopied != NIL
             SetDlgItemText( hWnd, 103, LTRIM( STR( nCopied ) ) )
          ENDIF
          cPercent := LTRIM( STR( C4W_Int( ( nDone / nTotalSize ) * 100 ) ) ) + '%'
          FillRect( hDC, MAX(nReplicate,1), 1, nRight-1, nBottom - 1, GetStockObject( LTGRAY_BRUSH ) )
          FillRect( hDC, 1, 1, MAX(nReplicate,1), nBottom - 1, hBrush )
          DrawText( hDC,cPercent,{ 0, 2, nRight, nBottom},DT_SINGLELINE+DT_CENTER)
       ENDIF
RETURN( NIL )

STATIC FUNCTION IsSelected( oB )
       LOCAL lSelected := BUTTONS->SELECTED

       IF lSelected
          lSelected := .F.
       ELSE
          lSelected := .T.
       ENDIF
       RLOCK()
       BUTTONS->SELECTED := lSelected
       DBRUNLOCK()
       DBCOMMIT()
       oB:refreshCol( 1 )
RETURN( NIL )

STATIC FUNCTION BHelp

       DialogBox(_GetInstance() , "buttons", ,;
                   {|hDlg, nMsg, nWparam, nLparam|;
                   MHello(hDlg, nMsg, nWparam, nLparam)})
RETURN(NIL)

STATIC FUNCTION MHello(hDlgWnd, nMsg, nWparam, nLparam)

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow(hDlgWnd)
               RETURN( 1 )

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK .OR. nWparam == IDCANCEL .OR.;
                       nWparam == IDABOUT
                       EndDialog( hDlgWnd, IDOK )
                       RETURN( 1 )
               ENDCASE
      ENDCASE
RETURN( 0 )

STATIC FUNCTION ShowInfo( aInfo )

       DialogBox( _GetInstance() , "info", ,  ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                 MInfo(hDlg, nMsg, nWparam, nLparam, aInfo )})
RETURN( NIL )

STATIC FUNCTION MInfo(hDlgWnd, nMsg, nWparam, nLparam, aInfo )

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow(hDlgWnd)
               CheckDlgButton( hDlgWnd, 101, IIF( aInfo[ 1 ], 1, 0 ) )
               CheckDlgButton( hDlgWnd, 102, IIF( aInfo[ 2 ], 1, 0 ) )
               CheckDlgButton( hDlgWnd, 103, IIF( aInfo[ 3 ], 1, 0 ) )
               CheckDlgButton( hDlgWnd, 104, IIF( aInfo[ 4 ], 1, 0 ) )
               CheckDlgButton( hDlgWnd, 105, IIF( aInfo[ 5 ], 1, 0 ) )
               CheckDlgButton( hDlgWnd, 106, IIF( aInfo[ 6 ], 1, 0 ) )
               CheckDlgButton( hDlgWnd, 107, IIF( aInfo[ 7 ], 1, 0 ) )
               SetDlgItemText( hDlgWnd, 108, aInfo[ 8 ] )
               SendMessage( hDlgWnd, WM_SETTEXT, 0 , aInfo[ 9 ] )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK
                       EndDialog(hDlgWnd,IDNO)
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

///////////////////// Browses ///////////////////////////

STATIC FUNCTION Browse1
       LOCAL oB, bFG, bBG

       ShowInfo( {.F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  "This demo browse offers 'in-cell' editing.  "+;
                  "To edit a record you first highlight the cell "+;
                  "then press the Enter key.  You can also double "+;
                  "click on the cell.  To perform a search you "+;
                  "press the F2 key.  To add a new record you "+;
                  "use Alt+A.  The Billing Rate field is edited "+;
                  "using a listbox...","Spreadsheet Style"} )

       bFG := {||IIF(MONTH(CHILD->BIRTHDAY) == MONTH(DATE()),RGB(255,255,255),RGB(0,0,0))}
       bBG := {||IIF(MONTH(CHILD->BIRTHDAY) == MONTH(DATE()),RGB(128,0,0),RGB(255,255,255))}

       SELECT CHILD
       GO TOP
       oB := WBrowseDB(hMainWnd,1,53,636,321,"Child List",WS_CHILD)
       oB:colorspec    := {RGB(0,0,0),RGB(255,255,255),RGB(255,255,255),RGB(0,0,128)}
       oB:autolite     := .F.
       oB:doubleClick  := {|oB,nCrecNo,nMode|CellEdit(oB,nCrecNo,nMode)}
       oB:destroyBlock := {||UnQueBrow()}
       oB:findBlock    := {|oB|FindKid(oB)}
       oB:aAltKeys     := { {VK_A,{|oB|AddKid(oB,1)} } }
       oB:showNumbers  := .T.
       oB:userSize     := .F.
       oB:userMove     := .F.
       oB:autoSize     := .F.
       oB:addColumn( WBColumnNew("CCODE",        {||CHILD->CCODE}) )
       oB:addColumn( WBColumnNew("LAST NAME",    {||CHILD->LAST_NAME}) )
       oB:addColumn( WBColumnNew("FIRST NAME",   {||CHILD->FIRST_NAME}) )
       oB:addColumn( WBColumnNew("BIRTHDAY",     {||DTOC(CHILD->BIRTHDAY)},NIL,bFG,bBG,DT_CENTER,90) )
       oB:addColumn( WBColumnNew("BILLING RATE", {||CHILD->RATE_CODE},NIL,NIL,NIL,DT_CENTER) )
       oB:addColumn( WBColumnNew("NOTES",        {||"<MEMO>"}) )
       oB:setColWidth(0,30)
       oB:setColWidth(1,70)
       oB:setColWidth(2,119)
       oB:setColWidth(3,119)
       oB:setColWidth(5,110)
       oB:setColWidth(6,70)
       QueBrowse( oB )
       oB:goTop()
RETURN(NIL)

STATIC FUNCTION Browse2
       LOCAL aBArray := {}
       LOCAL oB

       ShowInfo( {.F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  "This demo browse uses an array instead of a "+;
                  "database.  The Tuition and Discount cells can "+;
                  "be edited.  The 'Control Panel' is a modeless "+;
                  "dialog which can be moved out of the way if "+;
                  "it blocks your view!  Records CANNOT be "+;
                  "deleted or added...","Array Browse"})

       Working(.T.,"Building array...")
       SpinBall()
       SELECT CHILD
       GO TOP
       DO WHILE !EOF()
          SpinBall()
          AADD(aBArray,{LEFT(MakeName(),20),;
                        CHILD->TUITION     ,;
                        CHILD->DISCOUNT    ,;
                        CHILD->CCODE+'.TXT',;
                        RECNO()})
          SpinBall()
          SKIP
       ENDDO
       Working(.F.)
       SetCursor( LoadCursor( , IDC_ARROW ) )
       oB := WBrowseDB( hMainWnd, 80, 60, 590, 304, "Child List",;
                        WS_POPUP+WS_BORDER)
       oB:addColumn( WBColumnNew("NAME",    {||aBArray[oB:nCurRec][1]}) )
       oB:addColumn( WBColumnNew({"TUITION","PER WEEK"}, {||aBArray[oB:nCurRec][2]},"999.99") )
       oB:addColumn( WBColumnNew("DISCOUNT",{||aBArray[oB:nCurRec][3]},"99.99") )
       oB:addColumn( WBColumnNew("NOTES",   {||aBArray[oB:nCurRec][4]}) )
       oB:goTopBlock    := {|oB|AGoTop(oB, aBArray)}
       oB:goBottomBlock := {|oB|AGoBottom(oB, aBArray)}
       oB:skipBlock     := {|oB, nSkip|ASkipper(oB, nSkip, aBArray)}
       oB:scanBlock     := {|oB, cKey |AFindKey(oB, cKey, aBArray)}
       oB:doubleClick   := {|oB, nCrecNo, nMode|CellAEdit(oB,nCrecNo,nMode,aBArray)}
       oB:destroyBlock  := {||UnQueBrow(),KillNotePad()}
       oB:autoLite      := .F.
       oB:usermove      := .F.
       CenterWindow(oB:hWnd)
       QueBrowse( oB )
       oB:goTop()
       CreateDialog(_GetInstance() , "calc", oB:hWnd ,  ;
                    {|hDlg, nMsg, nWparam, nLparam|;
                    MCalc( hDlg, nMsg, nWparam, nLparam, aBArray, oB )})
       SetFocus(oB:hWnd)
       QueBrowse( oB )
RETURN(NIL)

STATIC FUNCTION Browse3
       LOCAL  hWnd, hDC, aCrect, nTop, nBottom, nCtr, oB

       ShowInfo( {.T.,;
                  .T.,;
                  .T.,;
                  .T.,;
                  .T.,;
                  .T.,;
                  .T.,;
                  "This demo browse shows a browse in a 'host' "+;
                  "window that has a toolbar/buttonbar.  You "+;
                  "can rearrange the visible columns by clicking "+;
                  "on a column heading and then 'dragging' the "+;
                  "column to it's new location.",;
                  "Host Window with Toolbar"})
       lBrowse := .T.
       SetButtons( .F. )
       SELECT CHILD
       hWnd := CreateWindow("BLIST",       ; // window class
                            "Child List",;
                             WS_CAPTION +     ;
                             WS_SYSMENU +     ;
                             WS_THICKFRAME +  ;
                             WS_MAXIMIZEBOX + ;
                             WS_MINIMIZEBOX,  ;
                             CW_USEDEFAULT,   ; // x co-ordinate
                             CW_USEDEFAULT,   ; // y co-ordinate
                             498,             ; // width
                             276,             ; // height
                             hMainWnd,        ;
                             0,               ;
                             _GetInstance())             // our own app instance
        HideCaret(hWnd)
        ShowWindow( hWnd, SW_HIDE )
        CenterWindow( hWnd )
        ShowWindow( hWnd, SW_SHOW )
        aCrect           := GetClientRect( hWnd )
        nTH              := TextHeight( hWnd )
        nTop             := nTH+9
        nBottom          := aCrect[ 4 ] - ( nTop + nTH + 10 )
        oB               := WBrowseDB(hWnd,0,nTop,aCrect[ 3 ],nBottom,"",WS_CHILD+WS_BORDER )
        oB:alias         := "CHILD"
        oB:colorspec     := {RGB(0,0,0),RGB(255,255,255),RGB(255,255,255),RGB(0,0,128)}
        oB:autolite      := .F.
        oB:showNumbers   := .T.
        oB:userSize      := .T.
        oB:autoSize      := .T.
        oB:escape        := .F.
        oB:doubleClick   := {|oB|AddKid( oB, 2 ) }
        oB:selectBlock   := {|oB|Message( hWnd, TRIM( CHILD->LAST_NAME )+", "+ CHILD->FIRST_NAME ) }
        oB:destroyBlock  := {||BrowEnd( oB ) }
        oB:nubBlock      := {|| FIELD->CCODE }
        oB:nubHeading    := "ID#"
        oB:nubAlign      := DT_CENTER
        oB:nubColor      := RGB(0,0,128)
        oB:nubWidth      := 80
        oB:nubClickBlock := {|oB|""}

        oB:addColumn(WBColumnNew("LAST NAME" ,{||CHILD->LAST_NAME } ) )
        oB:addColumn(WBColumnNew("FIRST NAME",{||CHILD->FIRST_NAME} ) )
        oB:addColumn(WBColumnNew("DOB",       {||DTOC(CHILD->BIRTHDAY )}))
        oB:addColumn(WBColumnNew("SEX",       {||CHILD->SEX}))
        oB:SetColBitmap( 1, 901 , DT_RIGHT )
        oB:SetHeadBlock( 1, {|nCol| FindKid( oB ), SetFocus( hWnd ) } )
        oB:goTop()
        oB:cargo := DrawButtons( hWnd, ARRAY(14,3), oB, .F. )
        BDoSubCl( hWnd , oB )
RETURN( NIL )

STATIC FUNCTION Browse4
       LOCAL  hWnd, hDC, aCrect, nTop, nBottom, nCtr, oB

       ShowInfo( {.T.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .T.,;
                  .T.,;
                  .T.,;
                  "This demo browse shows a browse in a 'host' "+;
                  "window that has a toolbar/buttonbar.  This "+;
                  "browse uses bitmaps as column headings and "+;
                  "allows the columns to be rearranged by the "+;
                  "user.","Browse With Bitmaps"})

       lBrowse := .T.
       SetButtons( .F. )
       SELECT CHILD
       hWnd := CreateWindow("BLIST",       ; // window class
                            "Child List",;
                             WS_CAPTION +     ;
                             WS_SYSMENU +     ;
                             WS_THICKFRAME +  ;
                             WS_MAXIMIZEBOX + ;
                             WS_MINIMIZEBOX,  ;
                             CW_USEDEFAULT,   ; // x co-ordinate
                             CW_USEDEFAULT,   ; // y co-ordinate
                             516,             ; // width
                             284,             ; // height
                             hMainWnd,        ;
                             0,               ;
                             _GetInstance())             // our own app instance
        HideCaret(hWnd)
        ShowWindow( hWnd, SW_HIDE )
        CenterWindow( hWnd )
        ShowWindow( hWnd, SW_SHOW )
        aCrect           := GetClientRect( hWnd )
        nTH              := TextHeight( hWnd )
        nTop             := nTH+9
        nBottom          := aCrect[ 4 ] - ( nTop + nTH + 10 )
        oB               := WBrowseDB(hWnd,0,nTop,aCrect[ 3 ],nBottom,"",WS_CHILD+WS_BORDER )
        oB:alias         := "CHILD"
        oB:colorspec     := {RGB(0,0,0),RGB(255,255,255),RGB(255,255,255),RGB(0,0,128)}
        oB:autolite      := .F.
        oB:showNumbers   := .T.
        oB:userSize      := .F.
        oB:autoSize      := .T.
        oB:escape        := .F.
        oB:doubleClick   := {|oB|AddKid( oB, 2 ) }
        oB:selectBlock   := {|oB|Message( hWnd, TRIM( CHILD->LAST_NAME )+", "+ CHILD->FIRST_NAME ) }
        oB:destroyBlock  := {||BrowEnd( oB ) }
        oB:nubBlock      := {|| FIELD->CCODE }
        oB:nubHeading    := NIL
        oB:nubAlign      := DT_CENTER
        oB:nubColor      := RGB(0,0,0)
        oB:nubWidth      := 80
        oB:addColumn(WBColumnNew("" ,{||CHILD->LAST_NAME+CHR(13)+CHR(10)+;
                                        TRIM(CHILD->FIRST_NAME )+" "+;
                                        IIF(!EMPTY(CHILD->MI), CHILD->MI+". ","")+;
                                        CHILD->JR_SR_III } ) )
        oB:addColumn(WBColumnNew("", {||DTOC(CHILD->BIRTHDAY )}))
        oB:addColumn(WBColumnNew("", {||IIF(CHILD->SEX == 'M',"Male   ","Female")}))
        oB:SetColBitMap( 0, BCCODE, DT_CENTER )
        oB:SetColBitMap( 1, BNAME,  DT_CENTER )
        oB:SetColBitMap( 2, BDOB,   DT_CENTER )
        oB:SetColBitMap( 3, BSEX,   DT_CENTER )
        oB:headHeight := 50
        oB:autoSize   := .F.

        oB:goTop()
        oB:cargo := DrawButtons( hWnd, ARRAY(14,3), oB, .T. )
        BDoSubCl( hWnd , oB )
RETURN( NIL )

STATIC FUNCTION Browse5
       LOCAL aFields := {{"NAME",{||LEFT(MakeName(),20)}}}

       ShowInfo( {.F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  "This demo shows the use of BListBox() in a "+;
                  "dialog box.  The radio button controls are "+;
                  "'read-only' in that any changes you make "+;
                  "are ignored.  Records cannot be modified "+;
                  "or deleted...","BListBox()"})
       SELECT CHILD
       GO TOP
       DialogBox( _GetInstance(), "box1", ,  ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                  MFoo1( hDlg, nMsg, nWparam, nLparam, aFields )})
RETURN(NIL)

STATIC FUNCTION MFoo1( hDlgWnd, nMsg, nWparam, nLparam, aFields )
       STATIC hBrowWnd
       STATIC aBlks := {}
       STATIC aRace := {'W','B','O'}
       STATIC oB
       LOCAL nCtr

       DO CASE
          CASE nMsg == WM_INITDIALOG
               AADD(aBlks,{||SetDlgItemText(hDlgWnd,101,CHILD->CCODE)})
               AADD(aBlks,{||SetDlgItemText(hDlgWnd,102,DTOC(CHILD->BIRTHDAY))})
               AADD(aBlks,{||SendMessage(hDlgWnd,WM_COMMAND,104+ASCAN(aRace,CHILD->RACE),0)})
               AADD(aBlks,{||SendMessage(hDlgWnd,WM_COMMAND,IIF(CHILD->SEX == 'M' , 103, 104),0)})
               CenterWindow(hDlgWnd)
               oB := BlistBox(hDlgWnd,;
                              GetDlgItem(hDlgWnd,999),;
                              aFields  ,;
                              NIL      ,;
                              NIL      ,;
                              NIL      ,;
                              "CHILD"   ,;
                              NIL      ,;
                              aBlks)
               AADD(aBlks,{||SetDlgItemText(hDlgWnd,108,LTRIM(STR(oB:nCurRec)))})
               oB:destroyBlock := {||UnQueBrow( .T. )}
               SetButtons( .F. )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK .OR. nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam >= 105 .AND. nWparam <= 107
                       FOR nCtr := 105 TO 107
                           CheckDlgButton( hDlgWnd, nCtr, 0 )
                       NEXT
                       CheckDlgButton( hDlgWnd, nWparam, 1)
                       RETURN(1)

                  CASE nWparam >= 103 .AND. nWparam <= 104
                       FOR nCtr := 103 TO 104
                           CheckDlgButton( hDlgWnd, nCtr, 0 )
                       NEXT
                       CheckDlgButton( hDlgWnd, nWparam, 1 )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION Browse6

       ShowInfo( {.T.,;
                  .T.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .T.,;
                  "This demo browse shows a BlistBox() browse "+;
                  "with bitmaps displayed on the 'nubs' and a "+;
                  "bitmap check mark used in a browse column.",;
                  "BListBox() - With Bitmaps"})
       SELECT BUTTONS
       GO TOP
       DialogBox( _GetInstance(), "box2", ,  ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                  MFoo2( hDlg, nMsg, nWparam, nLparam )})
RETURN(NIL)

STATIC FUNCTION MFoo2( hDlgWnd, nMsg, nWparam, nLparam )
       STATIC oB
       LOCAL nCtr, aFields[2]

       DO CASE
          CASE nMsg == WM_INITDIALOG
               aFields[1] := {"USE",{||IIF(BUTTONS->SELECTED,OBM_CHECK,0)},,,,DT_CENTER}
               aFields[2] := {{"DESCRIPTION","#define"},{||FIELD->DESCRIPT+CHR(13)+CHR(10)+;
                             TRIM(FIELD->TEXTID)+" ("+ALLTRIM(STR(FIELD->ID-1000))+')'}}
               CenterWindow(hDlgWnd)
               oB := BlistBox(hDlgWnd,;
                              GetDlgItem(hDlgWnd,999),;
                              aFields  ,;
                              NIL      ,;
                              NIL      ,;
                              NIL      ,;
                              "BUTTONS",;
                              NIL      ,;
                              {}       ,;
                              .F.       )
               oB:autolite     := .T.
               oB:showNumbers  := .T.
               oB:userSize     := .T.
               oB:userMove     := .F.
               oB:autoSize     := .T.
               oB:escape       := .F.
               oB:nubBlock     := {||FIELD->ID}
               oB:nubHeading   := NIL
               oB:nubAlign     := DT_CENTER
               oB:nubColor     := RGB(0,0,0)
               oB:nubWidth     := 60
               oB:nubClickBlock:= {|oB|IsSelected( oB )}
               oB:destroyBlock := {||UnQueBrow( .T. )}
               oB:lineHeight   := 60
               oB:headHeight   := 60
               SetButtons( .F. )
               oB:GoTop()
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK .OR. nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION Browse7

       ShowInfo( {.F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  .F.,;
                  "This demo browse shows a Calendar created "+;
                  "using BListBox().  Notes can be added, "+;
                  "edited, and deleted for a date.",;
                  "BListBox() - Calendar"})
       SELECT CAL
       GO TOP
       DialogBox( _GetInstance(), "cal", ,  ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                  MCal( hDlg, nMsg, nWparam, nLparam )})
RETURN(NIL)

STATIC FUNCTION MCal( hDlgWnd, nMsg, nWparam, nLparam )
       STATIC oB, nYear, nMonth, aCal[6][7]
       LOCAL  dSdate

       DO CASE
          CASE nMsg == WM_INITDIALOG
               CenterWindow( hDlgWnd )
               nYear  := YEAR( DATE() )
               nMonth := MONTH( DATE() )
               dSdate := CTOD( LTRIM( STR( nMonth ) )+'/01/'+STR( nYear, 4) )
               SetDlgItemText( hDlgWnd, 101, CMONTH( dSdate )+', '+STR(nYear,4))
               SetMonth( dSdate, aCal )
               oB := BlistBox(hDlgWnd,;
                              GetDlgItem(hDlgWnd,999),;
                              {},;
                              {|oB|AGoTop(oB, aCal)},;
                              {|oB|AGoBottom(oB, aCal)},;
                              {|oB,nSkip|ASkipper(oB, nSkip, aCal)},;
                              NIL      ,;
                              NIL      ,;
                              NIL      ,;
                              .F.)
               oB:addColumn( WBColumnNew("SUN", {||aCal[oB:nCurRec][1]},,{||RGB(192,0,0)}))
               oB:addColumn( WBColumnNew("MON", {||aCal[oB:nCurRec][2]},,{||RGB(0,0,0)}  ))
               oB:addColumn( WBColumnNew("TUE", {||aCal[oB:nCurRec][3]},,{||RGB(0,0,0)}  ))
               oB:addColumn( WBColumnNew("WED", {||aCal[oB:nCurRec][4]},,{||RGB(0,0,0)}  ))
               oB:addColumn( WBColumnNew("THU", {||aCal[oB:nCurRec][5]},,{||RGB(0,0,0)}  ))
               oB:addColumn( WBColumnNew("FRI", {||aCal[oB:nCurRec][6]},,{||RGB(0,0,0)}  ))
               oB:addColumn( WBColumnNew("SAT", {||aCal[oB:nCurRec][7]},,{||RGB(192,0,0)}))
               SetScrollRange(oB:hWnd,SB_VERT,0,0)
               oB:doubleClick   := {|oB|DailyLog( oB, nMonth, nYear, 2 )}
               oB:autoLite      := .F.
               oB:usermove      := .F.
               oB:userSize      := .F.
               oB:nubWidth      := 0
               oB:goTop()
               oB:hitTop        := .T.
               oB:hitBottom     := .T.
               SetFocus( GetDlgItem( hDlgWnd, 999 ) )
               RETURN(0)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == 1
                       EVAL( oB:doubleClick, oB, nMonth, nYear )
                       RETURN(1)

                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam == LARROW
                       IF nMonth > 1
                          --nMonth
                       ELSE
                          nMonth := 12
                          --nYear
                       ENDIF
                       dSdate := CTOD( LTRIM( STR( nMonth ) )+'/01/'+STR( nYear, 4) )
                       SetDlgItemText( hDlgWnd, 101, CMONTH( dSdate )+', '+STR(nYear,4))
                       SetMonth( dSdate, aCal )
                       oB:showData()
                       SetFocus( GetDlgItem( hDlgWnd, 999 ) )
                       RETURN(1)

                  CASE nWparam == RARROW
                       IF nMonth < 12
                          ++nMonth
                       ELSE
                          nMonth := 1
                          ++nYear
                       ENDIF
                       dSdate := CTOD( LTRIM( STR( nMonth ) )+'/01/'+STR( nYear, 4) )
                       SetDlgItemText( hDlgWnd, 101, CMONTH( dSdate )+', '+STR(nYear,4))
                       SetMonth( dSdate, aCal )
                       oB:showData()
                       SetFocus( GetDlgItem( hDlgWnd, 999 ) )
                       RETURN(1)

                  CASE nWparam == IDADD
                       DailyLog( oB, nMonth, nYear, 1 )
                       SetFocus( GetDlgItem( hDlgWnd, 999 ) )
                       RETURN(1)

                  CASE nWparam == IDEDIT
                       DailyLog( oB, nMonth, nYear, 2 )
                       SetFocus( GetDlgItem( hDlgWnd, 999 ) )
                       RETURN(1)

                  CASE nWparam == IDDEL
                       DailyLog( oB, nMonth, nYear, 3 )
                       SetFocus( GetDlgItem( hDlgWnd, 999 ) )
                       RETURN(1)

               ENDCASE
       ENDCASE
RETURN(0)

STATIC FUNCTION SetMonth( dSdate, aCal )
       LOCAL nCtr, nCtr2
       LOCAL nStart, nEnd, nDay1

       nDay1 := DOW( dSdate )

       DO CASE
          CASE MONTH( dSdate ) == MONTH( dSdate + 30 )
               nEnd := 31
          CASE MONTH( dSdate ) == MONTH( dSdate + 29 )
               nEnd := 30
          CASE MONTH( dSdate ) == MONTH( dSdate + 28 )
               nEnd := 29
          OTHERWISE
               nEnd := 28
       ENDCASE
       nStart := 1
       FOR nCtr := 1 TO 7
           IF nCtr < nDay1
              aCal[1][nCtr] := ""
           ELSE
              aCal[1][nCtr] := LTRIM(STR(nStart++))+CHR(13)+CHR(10)
           ENDIF
       NEXT
       FOR nCtr := 2 TO 6
           FOR nCtr2 := 1 TO 7
               IF nStart <= nEnd
                  aCal[nCtr][nCtr2] := LTRIM(STR(nStart++))+CHR(13)+CHR(10)
               ELSE
                  aCal[nCtr][nCtr2] := ""
               ENDIF
           NEXT
       NEXT
RETURN(NIL)

STATIC FUNCTION DailyLog( oB, nMonth, nYear, nMode )
       LOCAL aData := oB:CellData()
       LOCAL cDate
       LOCAL dTemp

       IF EMPTY( aData[1] )
          MessageBeep(MB_ICONEXCLAMATION)
          RETURN(NIL)
       ENDIF
       aData[1] := ALLTRIM(STRTRAN( aData[1], CHR(13)+CHR(10)))
       dTemp    := CTOD( LTRIM( STR( nMonth ) ) +'/'+aData[1]+'/'+STR(nYear,4) )
       cDate    := DTOS( dTemp )

       SEEK cDate
       DO CASE
          CASE nMode == 1  // Add
               IF !FOUND()
                  APPEND BLANK
                  CAL->DATE  := cDate
               ENDIF

          CASE nMode == 2  // Edit
               IF !FOUND()
                  Errormsg(hMainWnd,"No notes for selected date...",'E')
                  RETURN( NIL )
               ENDIF

          CASE nMode == 3  // Delete
              IF FOUND()
                 DELETE
              ENDIF
              RETURN( NIL )
       ENDCASE

       DialogBox(_GetInstance() , "notes", , ;
                 {|hDlg, nMsg, nWparam, nLparam|;
                  MCNotes( hDlg, nMsg, nWparam, nLparam, dTemp )})
RETURN(NIL)

STATIC FUNCTION MCNotes(hDlgWnd, nMsg, nWparam, nLparam, dTemp )

       DO CASE
          CASE nMsg == WM_INITDIALOG
               SendMessage( hDlgWnd, WM_SETTEXT, 0, "NOTES:  "+DTOC( dTemp ) )
               SetDlgItemText( hDlgWnd, 101, LEFT(CAL->NOTES,1400) )
               CenterWindow( hDlgWnd )
               RETURN(1)

          CASE nMsg == WM_COMMAND
               DO CASE
                  CASE nWparam == IDOK
                       CAL->NOTES := LEFT( GetDlgItmText( hDlgWnd, 101), 1400)
                       EndDialog( hDlgWnd, IDOK )
                       RETURN(1)

                  CASE nWparam == IDCANCEL
                       EndDialog( hDlgWnd, IDCANCEL )
                       RETURN(1)
               ENDCASE
       ENDCASE
RETURN(0)
